	.module test.c
	.dbfile test.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\spinuzza\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 38
; /*************************** Includes ********************************/
; #include <tjpbase.h>
; #include <stdio.h>
; /************************ End of Includes ****************************/
; 
; /*************************** Constants ********************************/
; #define AVOID_THRESHOLD 100
; #define IR_MAX 126
; #define IR_MIN 88
; #define MAX_RIGHT 75
; #define MAX_LEFT 100
; #define AMOUNT 40
; #define DELAY_TIME 25
; #define STOP 123
; #define NOWALL 95
; #define TURN 34
; #define TABLE_LENGTH 200
; /************************ End of Constants ****************************/
; #pragma interrupt_handler PAV_isr
; /*************************** Prototypes *********************************/
; void init_PA(void);
; void PAV_isr(void);
; void TURN_RIGHT(void);
; void TURN_LEFT(void);
; void TURN_AROUND(void);
; /************************ End of Prototypes *****************************/
; 
; int counter;
; int speedr;
; int speedl;
; 
; void main(void)
; /****************************** Main ***********************************/
; {
; 	int irdr, irdl, irdc;
; 	int std;
; 	int speedr, speedl;
; 	int diff, lastdiff, change;
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 44
; 
; 	int right[TABLE_LENGTH];
; 	int left[TABLE_LENGTH];
; 	int center[TABLE_LENGTH];
; 	int counter, maxcounter;
; 
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 57
; 	init_analog();
; 	init_motortjp();
; 	init_clocktjp();
; 
; 	IRE_ON;
; 
; 	speedr = MAX_RIGHT;
; 	speedl = MAX_LEFT;
; 	
; 	counter=0;
; 	
; 	START;
; 	
L4:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 63
; 	while(1)
; 	{
; 		irdr=RIGHT_IR;
; 		irdl=LEFT_IR;
; 		irdc=CENTER_IR;
; 
L5:
	rti
;  IX -> 0,x
_TOC4_isr::
	.dbfunc TOC4_isr
	.dbline 75
; 		left[counter]=irdl;
; 		center[counter]=irdc;
; 		right[counter]=irdr;
; 		
; 		counter=counter+1;
; 			
; 		if ((counter == TABLE_LENGTH) | (irdc > 122))
; 		{
; 			motorp(RIGHT_MOTOR, 0);
; 			motorp(LEFT_MOTOR, 0);
; 			maxcounter=counter;
; 			counter=0;
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 81
; 
; 			while(1)
; 			{
; 				START;
; 				while(counter<maxcounter)
; 				{
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 87
; 					printf("Table entry - %d %d %d\n",left[counter], center[counter], right[counter]);
; 					counter=counter+1;
; 				}
; 				printf("Number of entries: %d\n", counter);
; 			}
; 		}
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 99
; 
; 		if (irdr > irdl)
; 		{
; 			diff = ((irdr - irdl) * AMOUNT) / (IR_MAX - std);
; 			speedl = MAX_LEFT - diff;
; 		}
; 		
; 		if (irdl > irdr)
; 		{
; 			diff = ((irdl - irdr) * AMOUNT) / (IR_MAX - std);
; 			speedr = MAX_RIGHT - diff;
; 		}
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 105
; 		
; 		motorp(RIGHT_MOTOR, speedr);
; 		motorp(LEFT_MOTOR, speedl);
; 		wait(50);
; 	}
; 	
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 111
; 	
; 
; }
; 	
; 
; void PAV_isr(void)
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 117
; {
; 	counter=counter+1;
; 	if (counter==10)
; 	{
; 	 speedr=0;
; 	 speedl=0;
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 123
; 	}
; 	CLEAR_FLAG(TFLG2, 0x20);
; }
; 
; void init_PA(void)
; {
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 129
; 	INTR_OFF();
; 
; 	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
; 	SET_BIT(PACTL, 0x40); /*Enable PA*/
; 	
; 
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 135
; 	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
; 	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */
; 
; 	PACNT=0x00;
; 
; 	INTR_ON();
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 141
; }
; 
; void TURN_RIGHT(void)
; {
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
; 			motorp(LEFT_MOTOR, MAX_LEFT);
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 147
; 			wait(TURN*DELAY_TIME);
; 
; 			motorp(RIGHT_MOTOR, 0);
; 			motorp(LEFT_MOTOR, MAX_LEFT);
; 			wait(TURN * DELAY_TIME);
; 			
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 153
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
; 			motorp(LEFT_MOTOR, MAX_LEFT);
; 			wait(2 * TURN * DELAY_TIME);
; 
; 			speedr=MAX_RIGHT;
; 			speedl=MAX_LEFT;
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area text
;  IX -> 0,x
;  rMEM -> 2,x
;          ?temp -> 4,x
;          ?temp -> 6,x
;          ?temp -> 8,x
;         change -> 10,x
;       lastdiff -> 12,x
;            std -> 14,x
;         speedl -> 16,x
;         speedr -> 18,x
;           diff -> 20,x
;           irdc -> 22,x
;           irdl -> 24,x
;           irdr -> 26,x
;     maxcounter -> 28,x
;         center -> 30,x
;           left -> 430,x
;          right -> 830,x
;        counter -> 1230,x
_main::
	jsr __enter
	.word 0x4d0
	.dbfile test.c
	.dbfunc main
	.dbline 45
	jsr _init_analog
	.dbline 46
	jsr _init_motortjp
	.dbline 47
	jsr _init_clocktjp
	.dbline 49
	ldab #7
	stab 0x7000
	.dbline 51
	ldd #75
	std 18,x
	.dbline 52
	ldd #100
	std 16,x
	.dbline 54
	ldd 0,x
	addd #1230
	xgdy
	ldd #0
	std 0,y
L20:
	.dbline 56
L21:
	ldd #0
	jsr _analog
	cpd #120
	blt L20
	jmp L24
L23:
	.dbline 60
	ldd #2
	jsr _analog
	std 26,x
	.dbline 61
	ldd #3
	jsr _analog
	std 24,x
	.dbline 62
	ldd #7
	jsr _analog
	std 22,x
	.dbline 64
	ldd 0,x
	addd #1230
	xgdy
	ldd 0,y
	lsld
	pshb ; 
	psha ; spill
	ldd 0,x
	addd #430
	std 2,x
	pula ; 
	pulb ; reload
	addd 2,x
	xgdy
	ldd 24,x
	std 0,y
	.dbline 65
	ldd 0,x
	addd #1230
	xgdy
	ldd 0,y
	lsld
	pshb ; 
	psha ; spill
	ldd 0,x
	addd #30
	std 2,x
	pula ; 
	pulb ; reload
	addd 2,x
	xgdy
	ldd 22,x
	std 0,y
	.dbline 66
	ldd 0,x
	addd #1230
	xgdy
	ldd 0,y
	lsld
	pshb ; 
	psha ; spill
	ldd 0,x
	addd #830
	std 2,x
	pula ; 
	pulb ; reload
	addd 2,x
	xgdy
	ldd 26,x
	std 0,y
	.dbline 68
	ldd 0,x
	addd #1230
	xgdy
	ldd 0,y
	addd #1
	pshb ; 
	psha ; spill
	ldd 0,x
	addd #1230
	xgdy
	pula ; 
	pulb ; reload
	std 0,y
	.dbline 70
	ldd 0,x
	addd #1230
	xgdy
	ldd 0,y
	cpd #200
	bne L30
	ldd #1
	std 8,x
	bra L31
L30:
	ldd #0
	std 8,x
L31:
	ldd 22,x
	cpd #122
	ble L32
	ldd #1
	std 6,x
	bra L33
L32:
	ldd #0
	std 6,x
L33:
	ldd 8,x
	oraa 6,x
	orab 7,x
	cpd #0
	bne X0
	jmp L26
X0:
	.dbline 72
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 73
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 74
	ldd 0,x
	addd #1230
	xgdy
	ldd 0,y
	std 28,x
	.dbline 75
	ldd 0,x
	addd #1230
	xgdy
	ldd #0
	std 0,y
	jmp L35
L37:
	.dbline 79
L38:
	ldd #0
	jsr _analog
	cpd #120
	blt L37
	jmp L41
L40:
	.dbline 82
	ldd 0,x
	addd #1230
	xgdy
	ldd 0,y
	lsld
	std 4,x
	ldd 0,x
	addd #830
	std 2,x
	ldd 4,x
	addd 2,x
	xgdy
	ldd 0,y
	pshb
	psha
	ldd 0,x
	addd #30
	std 2,x
	ldd 4,x
	addd 2,x
	xgdy
	ldd 0,y
	pshb
	psha
	ldd 0,x
	addd #430
	std 2,x
	ldd 4,x
	addd 2,x
	xgdy
	ldd 0,y
	pshb
	psha
	ldd #L43
	jsr _printf
	jsr __movspb
	.byte 6
	.dbline 83
	ldd 0,x
	addd #1230
	xgdy
	ldd 0,y
	addd #1
	pshb ; 
	psha ; spill
	ldd 0,x
	addd #1230
	xgdy
	pula ; 
	pulb ; reload
	std 0,y
	.dbline 84
L41:
	.dbline 80
	ldd 0,x
	addd #1230
	xgdy
	ldd 0,y
	cpd 28,x
	bge X1
	jmp L40
X1:
	.dbline 85
	ldd 0,x
	addd #1230
	xgdy
	ldd 0,y
	pshb
	psha
	ldd #L44
	jsr _printf
	puly
	.dbline 86
L35:
	.dbline 77
	jmp L38
L26:
	.dbline 89
	ldd 26,x
	cpd 24,x
	ble L45
	.dbline 91
	ldd 26,x
	subd 24,x
	xgdy
	ldd #40
	jsr __muli
	pshb ; 
	psha ; spill
	ldd #126
	subd 14,x
	xgdy
	pula ; 
	pulb ; reload
	jsr __divi
	std 20,x
	.dbline 92
	ldd #100
	subd 20,x
	std 16,x
	.dbline 93
L45:
	.dbline 95
	ldd 24,x
	cpd 26,x
	ble L47
	.dbline 97
	ldd 24,x
	subd 26,x
	xgdy
	ldd #40
	jsr __muli
	pshb ; 
	psha ; spill
	ldd #126
	subd 14,x
	xgdy
	pula ; 
	pulb ; reload
	jsr __divi
	std 20,x
	.dbline 98
	ldd #75
	subd 20,x
	std 18,x
	.dbline 99
L47:
	.dbline 101
	ldd 18,x
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 102
	ldd 16,x
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 103
	ldd #50
	jsr _wait
	.dbline 104
L24:
	.dbline 58
	jmp L23
L19:
	xgdx
	addd #1232
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 113
	ldd _counter
	addd #1
	std _counter
	.dbline 114
	ldd _counter
	cpd #10
	bne L50
	.dbline 116
	ldd #0
	std _speedr
	.dbline 117
	ldd #0
	std _speedl
	.dbline 118
L50:
	.dbline 119
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 120
L49:
	rti
;  IX -> 0,x
_init_PA::
			sei

	.dbfunc init_PA
	.dbline 126
	ldy #0x1026
	bclr 0,y,#0xb0
	.dbline 127
	ldy #0x1026
	bset 0,y,#64
	.dbline 130
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 131
	ldy #0x1024
	bset 0,y,#32
	.dbline 133
	clr 0x1027
			cli

	.dbline 136
L52:
	rts
;  IX -> 0,x
_TURN_RIGHT::
	.dbfunc TURN_RIGHT
	.dbline 140
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 141
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 142
	ldd #850
	jsr _wait
	.dbline 144
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 145
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 146
	ldd #850
	jsr _wait
	.dbline 148
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 149
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 150
	ldd #1700
	jsr _wait
	.dbline 152
	ldd #75
	std _speedr
	.dbline 153
	ldd #100
	std _speedl
	.dbline 155
; 			
; 		}
L53:
	rts
;  IX -> 0,x
_TURN_LEFT::
	.dbfunc TURN_LEFT
	.dbline 159
; 
; void TURN_LEFT(void)
; {
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 160
; 			motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 161
; 			wait(TURN*DELAY_TIME);
	ldd #850
	jsr _wait
	.dbline 163
; 
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 164
; 			motorp(LEFT_MOTOR, 0);
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 165
; 			wait(TURN * DELAY_TIME);
	ldd #850
	jsr _wait
	.dbline 167
; 			
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 168
; 			motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 169
; 			wait(2 * TURN * DELAY_TIME);
	ldd #1700
	jsr _wait
	.dbline 171
; 
; 			speedr=MAX_RIGHT;
	ldd #75
	std _speedr
	.dbline 172
; 			speedl=MAX_LEFT;
	ldd #100
	std _speedl
	.dbline 174
; 			
; 		}
L54:
	rts
;  IX -> 0,x
_TURN_AROUND::
	.dbfunc TURN_AROUND
	.dbline 178
; 
; void TURN_AROUND(void)
; {
; 	motorp(RIGHT_MOTOR, -MAX_RIGHT);
	ldd #-75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 179
; 	motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 180
; 	wait((TURN - 4) * DELAY_TIME);
	ldd #750
	jsr _wait
	.dbline 181
; 	speedr = MAX_RIGHT;
	ldd #75
	std _speedr
	.dbline 182
; 	speedl = MAX_LEFT;
	ldd #100
	std _speedl
	.dbline 183
; }
L55:
	rts
	.area bss
_speedl::
	.blkb 2
_speedr::
	.blkb 2
_counter::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
	.area text
L44:
	.byte 'N,'u,'m,'b,'e,'r,32,'o,'f,32,'e,'n,'t,'r,'i,'e
	.byte 's,58,32,37,'d,10,0
L43:
	.byte 'T,'a,'b,'l,'e,32,'e,'n,'t,'r,'y,32,45,32,37,'d
	.byte 32,37,'d,32,37,'d,10,0
