	.module s3.c
	.dbfile s3.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\ICCTJP\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 38
; #include <stdio.h>
; #include <tjpbase.h>
; 
; #pragma interrupt_handler PAV_isr
; 
; void PAV_isr(void);
; 
; int counter;
; int speedr;
; int speedl;
; 
; void main(void)
; {
; 
; 	int speedr, speedl;
; 
; 	init_analog();
; 	init_clocktjp();
; 	init_motortjp();
; 	
; // init PA	
; 	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
; 	SET_BIT(PACTL, 0x40); /*Enable PA*/
; 	
; 
; 	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
; 	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */
; 
; 	INTR_ON();
; 
; 	START; // Press rear bumper to start program;
; 	
; 	
; 	speedr=100;
; 	speedl=100;
; 	
; 	while(1)
; 	{
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 44
; 		motorp(RIGHT_MOTOR, speedr);
; 		motorp(LEFT_MOTOR, speedl);
; 		wait(35);
; 	}
; }
; 
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 57
; void PAV_isr(void)
; {
; 	counter=counter+1;
; 	if(counter>2)
; 	{
; 		speedr=0;
; 		speedl=0;
; 	}
; 	
; 	CLEAR_FLAG(TFLG2, 0x20);
; }
; }
; }
L4:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 63
; }
; }
; }
; }
; }
; }
L5:
	rti
;  IX -> 0,x
_TOC4_isr::
	.dbfunc TOC4_isr
	.dbline 75
; }
; }
; }
; }
; }
; }
; }
; }
; }
; }
; }
; }
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 81
; }
; }
; }
; }
; }
; }
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 87
; }
; }
; }
; }
; }
; }
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 99
; }
; }
; }
; }
; }
; }
; }
; }
; }
; }
; }
; }
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 105
; }
; }
; }
; }
; }
; }
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 111
; }
; }
; }
; }
; }
; }
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 117
; }
; }
; }
; }
; }
; }
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 123
; }
; }
; }
; }
; }
; }
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 129
; }
; }
; }
; }
; }
; }
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 135
; }
; }
; }
; }
; }
; }
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 141
; }
; }
; }
; }
; }
; }
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 147
; }
; }
; }
; }
; }
; }
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 153
; }
; }
; }
; }
; }
; }
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area text
;  IX -> 0,x
;         speedl -> 2,x
;         speedr -> 4,x
_main::
	jsr __enterb
	.byte 0x6
	.dbfile s3.c
	.dbfunc main
	.dbline 17
	jsr _init_analog
	.dbline 18
	jsr _init_clocktjp
	.dbline 19
	jsr _init_motortjp
	.dbline 22
	ldy #0x1026
	bclr 0,y,#0xb0
	.dbline 23
	ldy #0x1026
	bset 0,y,#64
	.dbline 26
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 27
	ldy #0x1024
	bset 0,y,#32
			cli

	.dbline 29
L20:
	.dbline 31
L21:
	ldd #0
	jsr _analog
	cpd #120
	blt L20
	.dbline 34
	ldd #100
	std 4,x
	.dbline 35
	ldd #100
	std 2,x
	bra L24
L23:
	.dbline 39
	ldd 4,x
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 40
	ldd 2,x
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 41
	ldd #35
	jsr _wait
	.dbline 42
L24:
	.dbline 37
	bra L23
L19:
	xgdx
	addd #6
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 47
	ldd _counter
	addd #1
	std _counter
	.dbline 48
	ldd _counter
	cpd #2
	ble L27
	.dbline 50
	ldd #0
	std _speedr
	.dbline 51
	ldd #0
	std _speedl
	.dbline 52
L27:
	.dbline 54
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 55
L26:
	rti
	.area bss
_speedl::
	.blkb 2
_speedr::
	.blkb 2
_counter::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
