/*************************** Includes ********************************/

#include <tjpbase.h>
#include <stdio.h>

#pragma interrupt_handler PAV_isr

int counter;

void main(void)
{

	counter=0;
	
	IRE_ON;
	
	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
	SET_BIT(PACTL, 0x40); /*Enable PA*/
	
	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */

	asm("CLI");

	printf("Starting");

	while(counter < 5)
	{
	 asm("NOP");
	}
	
	printf("Done");
	
	while(1)
	{
	 asm("NOP");
	}

}

void PAV_isr(void)
{
	counter=counter+1;
	printf("Overflow");
	CLEAR_FLAG(TFLG2, 0x20);
}
