#include <stdio.h>
#include <tjpbase.h>

#pragma interrupt_handler PAV_isr

void PAV_isr(void);

int counter;
int speedr;
int speedl;

void main(void)
{

	int speedr, speedl;

	init_analog();
	init_clocktjp();
	init_motortjp();
	
// init PA	
	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
	SET_BIT(PACTL, 0x40); /*Enable PA*/
	

	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */

	INTR_ON();

	START; // Press rear bumper to start program;
	
	
	speedr=100;
	speedl=100;
	
	while(1)
	{
		motorp(RIGHT_MOTOR, speedr);
		motorp(LEFT_MOTOR, speedl);
		wait(35);
	}
}

void PAV_isr(void)
{
	counter=counter+1;
	if(counter>2)
	{
		speedr=0;
		speedl=0;
	}
	
	CLEAR_FLAG(TFLG2, 0x20);
}