	.module test6.c
	.dbfile test6.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\spinuzza\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 38
; /*************************** Includes ********************************/
; #include <tjpbase.h>
; #include <stdio.h>
; #include <algconst.h>
; /************************ End of Includes ****************************/
; 
; /*************************** Constants ********************************/
; #define TABLE_LENGTH 400
; 
; /************************ End of Constants ****************************/
; #pragma interrupt_handler PAV_isr
; /*************************** Prototypes *********************************/
; void init_PA(void);
; void PAV_isr(void);
; void TURN_RIGHT(void);
; void TURN_LEFT(void);
; void TURN_AROUND(void);
; /************************ End of Prototypes *****************************/
; 
; int counter;
; int speedr;
; int speedl;
; 
; int right[TABLE_LENGTH], left[TABLE_LENGTH], center[TABLE_LENGTH];
; 	
; int counter, maxcounter;
; 
; 
; void main(void)
; /****************************** Main ***********************************/
; {
; 	int irdr, irdl, irdc;
; 	int oldr, oldl;
; 	int newr, newl;
; 	int std;
; 	int diff;
; 	
; 	
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 44
; 	init_analog();
; 	init_motortjp();
; 	init_clocktjp();
; 
; 	IRE_ON;
; 
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 57
; 	speedr = MAX_RIGHT;
; 	speedl = MAX_LEFT;
; 	
; 	counter=0;
; 
; 	START;
; 	
; 	oldr=RIGHT_IR;
; 	oldl=LEFT_IR;
; 	
; 	
; 	std = (RIGHT_IR + LEFT_IR) / 2;
; 
L4:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 63
; 	while(1)
; 	{
; 		newl=LEFT_IR;
; 		newr=RIGHT_IR;
; 		irdc=CENTER_IR;
; 		
L5:
	rti
;  IX -> 0,x
_TOC4_isr::
	.dbfunc TOC4_isr
	.dbline 75
; 		irdl = (newl + oldl) / 2;
; 		irdr = (newr + oldr) / 2;
; 						
; 		right[counter]=irdr;
; 		center[counter]=irdc;
; 		left[counter]=irdl;
; 		counter=counter+1;
; 		
; 		if(counter>=TABLE_LENGTH)
; 		{
; 		 motorp(RIGHT_MOTOR,0);
; 		 motorp(LEFT_MOTOR,0);
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 81
; 		 while(1)
; 		 {
; 		  counter=0;
; 		  START;
; 		  printf("Starting\n");
; 		  while(counter<maxcounter)
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 87
; 		  {
; 		  	printf("Entry - %d %d %d\n",left[counter],center[counter],right[counter]);
; 			counter=counter+1;
; 		  }
; 		  printf("Total number of entries: %d\n",counter);
; 		 }
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 99
; 		}
; 		maxcounter=counter;
; 		
; 		if (irdr > irdl)
; 		{
; 			diff = ((irdr - irdl) * AMOUNT) / (IR_MAX - std);
; 			speedl = MAX_LEFT - diff;
; 		}
; 		
; 		if (irdl > irdr)
; 		{
; 			diff = ((irdl - irdr) * AMOUNT) / (IR_MAX - std);
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 105
; 			speedr = MAX_RIGHT - diff;
; 		}
; 		
; 
; 		if ((irdr <= NOWALL) & ((irdc >= NOWALL) | (irdl >= NOWALL)))
; 		{
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 111
; 			TURN_RIGHT();
; 			std = (RIGHT_IR + LEFT_IR) / 2;
; 
; 		}
; 		else if ((irdl <= NOWALL) & ((irdc >= NOWALL) | (irdr >= NOWALL)))
; 		{
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 117
; 			TURN_LEFT();
; 			std = (RIGHT_IR + LEFT_IR) / 2;
; 		}
; 			
; 		else if ((irdc >= STOP) & (irdr >= NOWALL) & (irdl >= NOWALL))
; 		{
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 123
; 			TURN_AROUND();
; 		}
; 		
; 		if((irdr < NOWALL) & (irdc < NOWALL) & (irdl < NOWALL))
; 		{
; 			motorp(RIGHT_MOTOR,0);
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 129
; 			motorp(LEFT_MOTOR,0);
; 			speedr=MAX_RIGHT;
; 			speedl=MAX_LEFT;
; 			START;
; 		}			 
; 
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 135
; 		if(FRONT_BUMP)
; 		{
; 			speedr=-MAX_RIGHT;
; 			speedl=-MAX_LEFT;
; 			motorp(RIGHT_MOTOR, speedr);
; 			motorp(LEFT_MOTOR, speedl);
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 141
; 			wait(10 * DELAY_TIME);
; 			counter=TABLE_LENGTH-1;
; 		}
; 				
; 		motorp(RIGHT_MOTOR, speedr);
; 		motorp(LEFT_MOTOR, speedl);
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 147
; 		wait(DELAY_TIME);
; 		
; 		oldl = newl;
; 		oldr = newr;
; 	}
; }
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 153
; 	
; 
; void PAV_isr(void)
; {
; 	CLEAR_FLAG(TFLG2, 0x20);
; }
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area text
;  IX -> 0,x
;  rMEM -> 2,x
;  func temp: 4,x - 16,x
;          ?temp -> 16,x
;          ?temp -> 18,x
;          ?temp -> 20,x
;          ?temp -> 22,x
;          ?temp -> 24,x
;          ?temp -> 26,x
;          ?temp -> 28,x
;          ?temp -> 30,x
;          ?temp -> 32,x
;          ?temp -> 34,x
;          ?temp -> 36,x
;          ?temp -> 38,x
;          ?temp -> 38,x
;            std -> 40,x
;           diff -> 42,x
;           oldl -> 44,x
;           oldr -> 46,x
;           newl -> 48,x
;           newr -> 50,x
;           irdc -> 52,x
;           irdl -> 54,x
;           irdr -> 56,x
_main::
	jsr __enterb
	.byte 0x3a
	.dbfile test6.c
	.dbfunc main
	.dbline 39
	jsr _init_analog
	.dbline 40
	jsr _init_motortjp
	.dbline 41
	jsr _init_clocktjp
	.dbline 43
	ldab #7
	stab 0x7000
	.dbline 45
	ldd #75
	std _speedr
	.dbline 46
	ldd #100
	std _speedl
	.dbline 48
	ldd #0
	std _counter
L20:
	.dbline 50
L21:
	ldd #0
	jsr _analog
	cpd #120
	blt L20
	.dbline 52
	ldd #2
	jsr _analog
	std 46,x
	.dbline 53
	ldd #3
	jsr _analog
	std 44,x
	.dbline 56
	ldd #2
	jsr _analog
	std 4,x
	ldd #3
	jsr _analog
	std 6,x
	ldd 4,x
	addd 6,x
	ldy #2
	jsr __divi
	std 40,x
	jmp L24
L23:
	.dbline 60
	ldd #3
	jsr _analog
	std 48,x
	.dbline 61
	ldd #2
	jsr _analog
	std 50,x
	.dbline 62
	ldd #7
	jsr _analog
	std 52,x
	.dbline 64
	ldd 48,x
	addd 44,x
	ldy #2
	jsr __divi
	std 54,x
	.dbline 65
	ldd 50,x
	addd 46,x
	ldy #2
	jsr __divi
	std 56,x
	.dbline 67
	ldd _counter
	lsld
	addd #_right
	xgdy
	ldd 56,x
	std 0,y
	.dbline 68
	ldd _counter
	lsld
	addd #_center
	xgdy
	ldd 52,x
	std 0,y
	.dbline 69
	ldd _counter
	lsld
	addd #_left
	xgdy
	ldd 54,x
	std 0,y
	.dbline 70
	ldd _counter
	addd #1
	std _counter
	.dbline 72
	ldd _counter
	cpd #400
	bge X0
	jmp L26
X0:
	.dbline 74
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 75
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L29
L28:
	.dbline 78
	ldd #0
	std _counter
L31:
	.dbline 79
L32:
	ldd #0
	jsr _analog
	cpd #120
	blt L31
	.dbline 80
	ldd #L34
	jsr _printf
	bra L36
L35:
	.dbline 83
	ldd _counter
	lsld
	std 38,x
	addd #_right
	xgdy
	ldd 0,y
	pshb
	psha
	ldd 38,x
	addd #_center
	xgdy
	ldd 0,y
	pshb
	psha
	ldd 38,x
	addd #_left
	xgdy
	ldd 0,y
	pshb
	psha
	ldd #L38
	jsr _printf
	jsr __movspb
	.byte 6
	.dbline 84
	ldd _counter
	addd #1
	std _counter
	.dbline 85
L36:
	.dbline 81
	ldd _counter
	cpd _maxcounter
	blt L35
	.dbline 86
	ldd _counter
	pshb
	psha
	ldd #L39
	jsr _printf
	puly
	.dbline 87
L29:
	.dbline 76
	bra L28
L26:
	.dbline 89
	ldd _counter
	std _maxcounter
	.dbline 91
	ldd 56,x
	cpd 54,x
	ble L40
	.dbline 93
	ldd 56,x
	subd 54,x
	xgdy
	ldd #300
	jsr __muli
	pshb ; 
	psha ; spill
	ldd #126
	subd 40,x
	xgdy
	pula ; 
	pulb ; reload
	jsr __divi
	std 42,x
	.dbline 94
	ldd #100
	subd 42,x
	std _speedl
	.dbline 95
L40:
	.dbline 97
	ldd 54,x
	cpd 56,x
	ble L42
	.dbline 99
	ldd 54,x
	subd 56,x
	xgdy
	ldd #300
	jsr __muli
	pshb ; 
	psha ; spill
	ldd #126
	subd 40,x
	xgdy
	pula ; 
	pulb ; reload
	jsr __divi
	std 42,x
	.dbline 100
	ldd #75
	subd 42,x
	std _speedr
	.dbline 101
L42:
	.dbline 104
	ldd 56,x
	cpd #90
	bgt L49
	ldd #1
	std 38,x
	bra L50
L49:
	ldd #0
	std 38,x
L50:
	ldd 52,x
	cpd #90
	blt L51
	ldd #1
	std 36,x
	bra L52
L51:
	ldd #0
	std 36,x
L52:
	ldd 54,x
	cpd #90
	blt L53
	ldd #1
	std 34,x
	bra L54
L53:
	ldd #0
	std 34,x
L54:
	ldd 36,x
	oraa 34,x
	orab 35,x
	std 2,x
	ldd 38,x
	anda 2,x
	andb 3,x
	cpd #0
	beq L44
	.dbline 106
	jsr _TURN_RIGHT
	.dbline 107
	ldd #2
	jsr _analog
	std 8,x
	ldd #3
	jsr _analog
	std 10,x
	ldd 8,x
	addd 10,x
	ldy #2
	jsr __divi
	std 40,x
	.dbline 109
	jmp L45
L44:
	.dbline 110
	ldd 54,x
	cpd #90
	bgt L60
	ldd #1
	std 32,x
	bra L61
L60:
	ldd #0
	std 32,x
L61:
	ldd 52,x
	cpd #90
	blt L62
	ldd #1
	std 30,x
	bra L63
L62:
	ldd #0
	std 30,x
L63:
	ldd 56,x
	cpd #90
	blt L64
	ldd #1
	std 28,x
	bra L65
L64:
	ldd #0
	std 28,x
L65:
	ldd 30,x
	oraa 28,x
	orab 29,x
	std 2,x
	ldd 32,x
	anda 2,x
	andb 3,x
	cpd #0
	beq L55
	.dbline 112
	jsr _TURN_LEFT
	.dbline 113
	ldd #2
	jsr _analog
	std 12,x
	ldd #3
	jsr _analog
	std 14,x
	ldd 12,x
	addd 14,x
	ldy #2
	jsr __divi
	std 40,x
	.dbline 114
	bra L56
L55:
	.dbline 116
	ldd 52,x
	cpd #123
	blt L71
	ldd #1
	std 26,x
	bra L72
L71:
	ldd #0
	std 26,x
L72:
	ldd 56,x
	cpd #90
	blt L73
	ldd #1
	std 24,x
	bra L74
L73:
	ldd #0
	std 24,x
L74:
	ldd 54,x
	cpd #90
	blt L75
	ldd #1
	std 22,x
	bra L76
L75:
	ldd #0
	std 22,x
L76:
	ldd 26,x
	anda 24,x
	andb 25,x
	anda 22,x
	andb 23,x
	cpd #0
	beq L66
	.dbline 118
	jsr _TURN_AROUND
	.dbline 119
L66:
L56:
L45:
	.dbline 121
	ldd 56,x
	cpd #90
	bge L82
	ldd #1
	std 20,x
	bra L83
L82:
	ldd #0
	std 20,x
L83:
	ldd 52,x
	cpd #90
	bge L84
	ldd #1
	std 18,x
	bra L85
L84:
	ldd #0
	std 18,x
L85:
	ldd 54,x
	cpd #90
	bge L86
	ldd #1
	std 16,x
	bra L87
L86:
	ldd #0
	std 16,x
L87:
	ldd 20,x
	anda 18,x
	andb 19,x
	anda 16,x
	andb 17,x
	cpd #0
	beq L77
	.dbline 123
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 124
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 125
	ldd #75
	std _speedr
	.dbline 126
	ldd #100
	std _speedl
L88:
	.dbline 127
L89:
	ldd #0
	jsr _analog
	cpd #120
	blt L88
	.dbline 128
L77:
	.dbline 130
	ldd #0
	jsr _analog
	cpd #38
	ble L91
	ldd #0
	jsr _analog
	cpd #120
	bge L91
	.dbline 132
	ldd #-75
	std _speedr
	.dbline 133
	ldd #-100
	std _speedl
	.dbline 134
	ldd _speedr
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 135
	ldd _speedl
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 136
	ldd #250
	jsr _wait
	.dbline 137
	ldd #399
	std _counter
	.dbline 138
L91:
	.dbline 140
	ldd _speedr
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 141
	ldd _speedl
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 142
	ldd #25
	jsr _wait
	.dbline 144
	ldd 48,x
	std 44,x
	.dbline 145
	ldd 50,x
	std 46,x
	.dbline 146
L24:
	.dbline 58
	jmp L23
L19:
	xgdx
	addd #58
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 152
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 153
L93:
	rti
;  IX -> 0,x
_init_PA::
			sei

	.dbfunc init_PA
	.dbline 159
; 
; void init_PA(void)
; {
; 	INTR_OFF();
; 
; 	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
	ldy #0x1026
	bclr 0,y,#0xb0
	.dbline 160
; 	SET_BIT(PACTL, 0x40); /*Enable PA*/
	ldy #0x1026
	bset 0,y,#64
	.dbline 163
; 	
; 
; 	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 164
; 	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */
	ldy #0x1024
	bset 0,y,#32
	.dbline 166
; 
; 	PACNT=0x00;
	clr 0x1027
			cli

	.dbline 169
; 
; 	INTR_ON();
; }
L94:
	rts
;  IX -> 0,x
_TURN_RIGHT::
	.dbfunc TURN_RIGHT
	.dbline 173
; 
; void TURN_RIGHT(void)
; {
; 	motorp(RIGHT_MOTOR, MAX_RIGHT);
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 174
; 	motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 175
; 	wait(TURN_DELAY/2);
	ldd #425
	jsr _wait
	.dbline 177
; 
; 	motorp(RIGHT_MOTOR, 0);
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 178
; 	motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 179
; 	wait(TURN_DELAY);
	ldd #850
	jsr _wait
	.dbline 181
; 		
; 	motorp(RIGHT_MOTOR, MAX_RIGHT);
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 182
; 	motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 183
; 	wait(TURN_DELAY/2);
	ldd #425
	jsr _wait
	.dbline 185
; 
; 	speedr=MAX_RIGHT;
	ldd #75
	std _speedr
	.dbline 186
; 	speedl=MAX_LEFT;
	ldd #100
	std _speedl
	.dbline 188
; 
; 	left[counter]=0;
	ldd _counter
	lsld
	addd #_left
	xgdy
	ldd #0
	std 0,y
	.dbline 189
; 	center[counter]=0;
	ldd _counter
	lsld
	addd #_center
	xgdy
	ldd #0
	std 0,y
	.dbline 190
; 	right[counter]=IR_MAX;
	ldd _counter
	lsld
	addd #_right
	xgdy
	ldd #126
	std 0,y
	.dbline 192
; 			
; 	counter=counter+1;
	ldd _counter
	addd #1
	std _counter
	.dbline 193
; 	maxcounter=counter;
	ldd _counter
	std _maxcounter
	.dbline 195
; 			
; }
L95:
	rts
;  IX -> 0,x
_TURN_LEFT::
	.dbfunc TURN_LEFT
	.dbline 199
; 
; void TURN_LEFT(void)
; {
; 	motorp(RIGHT_MOTOR, MAX_RIGHT);
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 200
; 	motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 201
; 	wait(TURN_DELAY/2);
	ldd #425
	jsr _wait
	.dbline 203
; 
; 	motorp(RIGHT_MOTOR, MAX_RIGHT);
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 204
; 	motorp(LEFT_MOTOR, 0);
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 205
; 	wait(TURN_DELAY);
	ldd #850
	jsr _wait
	.dbline 207
; 			
; 	motorp(RIGHT_MOTOR, MAX_RIGHT);
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 208
; 	motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 209
; 	wait(TURN_DELAY/2);
	ldd #425
	jsr _wait
	.dbline 211
; 
; 	speedr=MAX_RIGHT;
	ldd #75
	std _speedr
	.dbline 212
; 	speedl=MAX_LEFT;
	ldd #100
	std _speedl
	.dbline 214
; 
; 	left[counter]=IR_MAX;
	ldd _counter
	lsld
	addd #_left
	xgdy
	ldd #126
	std 0,y
	.dbline 215
; 	center[counter]=0;
	ldd _counter
	lsld
	addd #_center
	xgdy
	ldd #0
	std 0,y
	.dbline 216
; 	right[counter]=0;
	ldd _counter
	lsld
	addd #_right
	xgdy
	ldd #0
	std 0,y
	.dbline 218
; 			
; 	counter=counter+1;
	ldd _counter
	addd #1
	std _counter
	.dbline 219
; 	maxcounter=counter;
	ldd _counter
	std _maxcounter
	.dbline 221
; 			
; 		}
L96:
	rts
;  IX -> 0,x
_TURN_AROUND::
	.dbfunc TURN_AROUND
	.dbline 225
; 
; void TURN_AROUND(void)
; {
; 	motorp(RIGHT_MOTOR, -MAX_RIGHT);
	ldd #-75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 226
; 	motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 227
; 	wait(TURN_AROUND_DELAY);
	ldd #800
	jsr _wait
	.dbline 228
; 	speedr = MAX_RIGHT;
	ldd #75
	std _speedr
	.dbline 229
; 	speedl = MAX_LEFT;
	ldd #100
	std _speedl
	.dbline 231
; 
; 	left[counter]=0;
	ldd _counter
	lsld
	addd #_left
	xgdy
	ldd #0
	std 0,y
	.dbline 232
; 	center[counter]=IR_MAX;
	ldd _counter
	lsld
	addd #_center
	xgdy
	ldd #126
	std 0,y
	.dbline 233
; 	right[counter]=0;
	ldd _counter
	lsld
	addd #_right
	xgdy
	ldd #0
	std 0,y
	.dbline 235
; 			
; 	counter=counter+1;
	ldd _counter
	addd #1
	std _counter
	.dbline 236
; 	maxcounter=counter;
	ldd _counter
	std _maxcounter
	.dbline 238
; 
; }
L97:
	rts
	.area bss
_maxcounter::
	.blkb 2
_center::
	.blkb 800
_left::
	.blkb 800
_right::
	.blkb 800
_speedl::
	.blkb 2
_speedr::
	.blkb 2
_counter::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
	.area text
L39:
	.byte 'T,'o,'t,'a,'l,32,'n,'u,'m,'b,'e,'r,32,'o,'f,32
	.byte 'e,'n,'t,'r,'i,'e,'s,58,32,37,'d,10,0
L38:
	.byte 'E,'n,'t,'r,'y,32,45,32,37,'d,32,37,'d,32,37,'d
	.byte 10,0
L34:
	.byte 'S,'t,'a,'r,'t,'i,'n,'g,10,0
