#pragma interrupt_handler PAV_isr

void init_PA(void);
void PAV_isr(void);
void TURN_RIGHT(void);
void TURN_LEFT(void);
void TURN_AROUND(void);
void OLD_RIGHT(void);
void OLD_LEFT(void);
void OLD_AROUND(void);

int speedr;
int speedl;

void init_PA(void)
{
	INTR_OFF();

	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
	SET_BIT(PACTL, 0x40); /*Enable PA*/
	

	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */

	PACNT=0x00;

	INTR_ON();
}

void PAV_isr(void)
{
	CLEAR_FLAG(TFLG2, 0x20);
}

//The following are templates for the turn routines

void TURN_RIGHT(void)
{

			motorp(RIGHT_MOTOR, 0);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(TURN_DELAY);

}


void OLD_RIGHT(void)
{
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(STRAIGHT_DELAY);

			motorp(RIGHT_MOTOR, 0);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(TURN_DELAY);
			
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(STRAIGHT_DELAY);

			speedr=MAX_RIGHT;
			speedl=MAX_LEFT;
			
		}

void TURN_LEFT(void)
{
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, 0);
			wait(TURN_DELAY);
}

void OLD_LEFT(void)
{
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(STRAIGHT_DELAY);

			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, 0);
			wait(TURN_DELAY);
			
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(STRAIGHT_DELAY);

			speedr=MAX_RIGHT;
			speedl=MAX_LEFT;
			
		}
void TURN_AROUDN(void)
{
	motorp(RIGHT_MOTOR, -MAX_RIGHT);
	motorp(LEFT_MOTOR, MAX_LEFT);
	while(CENTER_IR > 100)
	speedr = MAX_RIGHT;
	speedl = MAX_LEFT;
}


void OLD_AROUND(void)
{
	motorp(RIGHT_MOTOR, -MAX_RIGHT);
	motorp(LEFT_MOTOR, MAX_LEFT);
	wait(TURN_AROUND_DELAY);
	speedr = MAX_RIGHT;
	speedl = MAX_LEFT;
}
