/************************************************************************
 * 			MEKATRONIX Copyright 1998 		        *
 * Title        vectors.h                                               *
 * Programmer   Keith L. Doty                                           *
 * Date         Sept 04, 1998                                           *
 * Version      1                                                       *
 *                                                                      *
 * Description								*
 *   This header file refers to the interrupt vectors for TJ Pro. 	*
 *   Object file in libtjp.a.                                           *
 *
 *   This file is designed to force the compiler to include the vectors
 *   file from the library. It is NOT necessary if you include your
 *   own vectors.c in the source or at the command line (object code).
 *   Note that it puts the variable name 'drew' in the namespace.
 ************************************************************************/

#ifndef _VECTORS_H
#define _VECTORS_H

const extern void (*interrupt_vectors[])();
const void* drew = interrupt_vectors; /* Necessary for linker */

#endif

