#include <limits.h>

#define LONG_FACTOR	(INT_MAX+1L)

long _c_fp2long(float f)
	{
	int isneg = 0;
	int i;
	int quo;
	long l;
	
	if (f < 0.0)
		{
		isneg = 1;
		f = -f;
		}
	quo = f / LONG_FACTOR;

	i = f - (float)LONG_FACTOR*quo;
	l = quo * LONG_FACTOR + i;
	return isneg ? -l : l;
	}

