/* asin and acos as identities of atan, and fmod  Rob Chapman  Apr 25, 1998 */

#include <math.h>  /* thanks // richard */

double acos(double x)
{
	return(2.0 * atan(sqrt((1.0 - x) / (1.0 + x))));
}

double asin(double x)
{
	double y = fabs(x);

	if (y > 0.5)
	{
		y = 1.0 - y;
		y = 2.0 * y - y * y;
	}
	else
		y = 1.0 - y * y;

	return(atan(x/sqrt(y)));
}

