	.text

; jsr __enter
; .word size_of_frame << 2
;   bit 14 - pshd
;   bit 15 - allocate lreg
;
__enter::
	puly	; y has the return address
	brclr 0,y,#0x40,no_pshd
	pshb
	psha
no_pshd:
	pshx	; save old frame ptr
	tsx	; address of sp in X
	ldd 0,y	; get size of frame
	anda #0x3F	; mask off high 2 bits
	pshb
	psha		; push size of frame on stack
	xgdx		; get address of sp in D
	tsx
	subd 0,x	; subtract size of frame
	xgdx
	txs			; set sp to new address
	stx 0,x		; store current IX
	brclr 0,y,#0x80,no_lreg
	; allocate 8 bytes
	pshx
	pshx
	pshx
	pshx
no_lreg:
	jmp	2,y	; skip the .word

; jsr __movsp
; .word size_of_argblock
;
; deallocate stack space used by a function call
__movsp::
	tsy
	pshb 		; save D
	psha
	xgdy		; D <- old stack pointer
  ; we want D <- (new stack pointer - 2)
  ; new stack pointer == old stack pointer + 2 (skip rts) + .byte
  ; thus want D <- old stack pointer + .byte
	tsy
	ldy 2,y		; y has the return address
				; 0,y is the .byte
	addd 0,y	; D has the new stack ptr
  ; 
    tsy
	ldy 2,y		; y has the return address
	xgdy		; D <- return address
				; Y <- new stack pointer
	addd #2		; adjust D to skip past the .byte
	std 0,y		; put return address on stack
	pula		; restore D
	pulb
	tys			; put new stack pointer
	rts
