	.module final.c
	.dbfile final.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\spinuzza\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 38
; //battery must be fully charged for it to stop
; 
; /*************************** Includes ********************************/
; #include <tjpbase.h>
; #include <stdio.h>
; /************************ End of Includes ****************************/
; 
; /*************************** Constants ********************************/
; #define PAV_TURN	0x40
; #define PAV_STRAIGHT 0x80
; #define AVOID_THRESHOLD 100
; #define IR_MAX 126
; #define IR_MIN 88
; #define MAX_RIGHT 75
; #define MAX_LEFT 100
; #define AMOUNT 300
; #define DELAY_TIME 25
; #define STOP 123
; #define NOWALL 90
; #define WALL 105
; #define STRAIGHT_DELAY 550
; #define TURN_DELAY 850
; #define TURN_AROUND_DELAY 800
; #define NOWALL2 96
; #define WALL2 100
; 
; /************************ End of Constants ****************************/
; #pragma interrupt_handler PAV_isr
; /*************************** Prototypes *********************************/
; void init_PA(void);
; void PAV_isr(void);
; void TURN_RIGHT(void);
; void TURN_LEFT(void);
; void TURN_AROUND(void);
; void first(void);
; void second(void);
; void third(void);
; void PA_ON(void);
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 44
; void PA_OFF(void);
; void STRAIGHTEN(void);
; /************************ End of Prototypes *****************************/
; 
; int speedr, speedl;
; int counter;
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 57
; int done;
; int repeat;
; 
; void main(void)
; {
; 	printf("\n");
; 	while(1)
; 	{
; 		repeat=0;
; 		while(repeat==0)
; 		{
; 			printf("One\n");
; 			first();
L4:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 63
; 
; 			while(BUMPER < 20)
; 			{
; 				printf("One or Two\n");
; 				if(FRONT_BUMP)
; 				{
L5:
	rti
;  IX -> 0,x
_TOC4_isr::
	.dbfunc TOC4_isr
	.dbline 75
; 					repeat=0;
; 				}
; 				else if(BACK_BUMP)
; 				{
; 					repeat=1;
; 				}
; 			}
; 			wait(5000);
; 			START;
; 		}
; 		repeat=0;
; 		while(repeat==0)
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 81
; 		{
; 			printf("Two\n");
; 			second();
; 			
; 			while(BUMPER < 20)
; 			{
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 87
; 				if(FRONT_BUMP)
; 				{
; 					repeat=0;
; 				}
; 				else if(BACK_BUMP)
; 				{
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 99
; 					repeat=1;
; 				}
; 			}
; 			wait(5000);
; 			START;
; 		}
; 		repeat=0;
; 		while(repeat==0)
; 		{
; 			printf("Three\n");
; 			third();
; 		
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 105
; 			while(BUMPER < 20)
; 			{
; 				if(FRONT_BUMP)
; 				{
; 					repeat=0;
; 				}
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 111
; 				else if(BACK_BUMP)
; 				{
; 					repeat=1;
; 				}
; 			}
; 			wait(5000);
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 117
; 			START;
; 		}
; 	}
; }
; 
; void first(void)
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 123
; /****************************** Main ***********************************/
; {
; 	int irdr, irdl, irdc;
; 	int diff;
; 
; 	init_analog();
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 129
; 	init_motortjp();
; 	init_clocktjp();
; 
; 	IRE_ON;
; 
; 	speedr = MAX_RIGHT;
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 135
; 	speedl = MAX_LEFT;
; 	
; 	done=0;
; 
; 	START;
; 	
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 141
; 	while(done == 0)
; 	{
; 		
; 		speedr=MAX_RIGHT;
; 		speedl=MAX_LEFT;
; 	
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 147
; 		irdr=RIGHT_IR;
; 		irdl=LEFT_IR;
; 		irdc=CENTER_IR;
; 
; 		if(irdr >= WALL)
; 		{
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 153
; 			diff = irdr - WALL;
; 			
; 			if(diff >= 1)
; 			{
; 			 speedl = MAX_LEFT - 25;
; 			}
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area text
;  IX -> 0,x
_main::
	.dbfile final.c
	.dbfunc main
	.dbline 50
	ldd #L20
	jsr _printf
	jmp L22
L21:
	.dbline 53
	ldd #0
	std _repeat
	bra L25
L24:
	.dbline 56
	ldd #L27
	jsr _printf
	.dbline 57
	jsr _first
	bra L29
L28:
	.dbline 61
	ldd #L31
	jsr _printf
	.dbline 62
	ldd #0
	jsr _analog
	cpd #38
	ble L32
	ldd #0
	jsr _analog
	cpd #120
	bge L32
	.dbline 64
	ldd #0
	std _repeat
	.dbline 65
	bra L33
L32:
	.dbline 66
	ldd #0
	jsr _analog
	cpd #120
	ble L34
	.dbline 68
	ldd #1
	std _repeat
	.dbline 69
L34:
L33:
	.dbline 70
L29:
	.dbline 59
	ldd #0
	jsr _analog
	cpd #20
	blt L28
	.dbline 71
	ldd #5000
	jsr _wait
L36:
	.dbline 72
L37:
	ldd #0
	jsr _analog
	cpd #120
	blt L36
	.dbline 73
L25:
	.dbline 54
	ldd _repeat
	beq L24
	.dbline 74
	ldd #0
	std _repeat
	bra L40
L39:
	.dbline 77
	ldd #L42
	jsr _printf
	.dbline 78
	jsr _second
	bra L44
L43:
	.dbline 82
	ldd #0
	jsr _analog
	cpd #38
	ble L46
	ldd #0
	jsr _analog
	cpd #120
	bge L46
	.dbline 84
	ldd #0
	std _repeat
	.dbline 85
	bra L47
L46:
	.dbline 86
	ldd #0
	jsr _analog
	cpd #120
	ble L48
	.dbline 88
	ldd #1
	std _repeat
	.dbline 89
L48:
L47:
	.dbline 90
L44:
	.dbline 80
	ldd #0
	jsr _analog
	cpd #20
	blt L43
	.dbline 91
	ldd #5000
	jsr _wait
L50:
	.dbline 92
L51:
	ldd #0
	jsr _analog
	cpd #120
	blt L50
	.dbline 93
L40:
	.dbline 75
	ldd _repeat
	beq L39
	.dbline 94
	ldd #0
	std _repeat
	bra L54
L53:
	.dbline 97
	ldd #L56
	jsr _printf
	.dbline 98
	jsr _third
	bra L58
L57:
	.dbline 102
	ldd #0
	jsr _analog
	cpd #38
	ble L60
	ldd #0
	jsr _analog
	cpd #120
	bge L60
	.dbline 104
	ldd #0
	std _repeat
	.dbline 105
	bra L61
L60:
	.dbline 106
	ldd #0
	jsr _analog
	cpd #120
	ble L62
	.dbline 108
	ldd #1
	std _repeat
	.dbline 109
L62:
L61:
	.dbline 110
L58:
	.dbline 100
	ldd #0
	jsr _analog
	cpd #20
	blt L57
	.dbline 111
	ldd #5000
	jsr _wait
L64:
	.dbline 112
L65:
	ldd #0
	jsr _analog
	cpd #120
	blt L64
	.dbline 113
L54:
	.dbline 95
	ldd _repeat
	beq L53
	.dbline 114
L22:
	.dbline 51
	jmp L21
L19:
	rts
;  IX -> 0,x
;          ?temp -> 2,x
;          ?temp -> 4,x
;          ?temp -> 6,x
;          ?temp -> 8,x
;          ?temp -> 10,x
;          ?temp -> 12,x
;           irdc -> 14,x
;           irdl -> 16,x
;           diff -> 18,x
;           irdr -> 20,x
_first::
	jsr __enterb
	.byte 0x16
	.dbfunc first
	.dbline 123
	jsr _init_analog
	.dbline 124
	jsr _init_motortjp
	.dbline 125
	jsr _init_clocktjp
	.dbline 127
	ldab #7
	stab 0x7000
	.dbline 129
	ldd #75
	std _speedr
	.dbline 130
	ldd #100
	std _speedl
	.dbline 132
	ldd #0
	std _done
L68:
	.dbline 134
L69:
	ldd #0
	jsr _analog
	cpd #120
	blt L68
	jmp L72
L71:
	.dbline 139
	ldd #75
	std _speedr
	.dbline 140
	ldd #100
	std _speedl
	.dbline 142
	ldd #2
	jsr _analog
	std 20,x
	.dbline 143
	ldd #3
	jsr _analog
	std 16,x
	.dbline 144
	ldd #7
	jsr _analog
	std 14,x
	.dbline 146
	ldd 20,x
	cpd #105
	blt L74
	.dbline 148
	ldd 20,x
	subd #105
	std 18,x
	.dbline 150
	ldd 18,x
	cpd #1
	blt L76
	.dbline 152
	ldd #75
	std _speedl
	.dbline 153
L76:
	.dbline 154
; 			if(diff >= 2)
	ldd 18,x
	cpd #2
	blt L78
	.dbline 156
; 			{
; 			 speedl = MAX_LEFT - 40;
	ldd #60
	std _speedl
	.dbline 157
; 			}
L78:
	.dbline 158
; 			if(diff >= 4)
	ldd 18,x
	cpd #4
	blt L80
	.dbline 160
; 			{
; 			 speedl = MAX_LEFT - 75;
	ldd #25
	std _speedl
	.dbline 161
; 			}
L80:
	.dbline 162
; 			if(diff >= 6)
	ldd 18,x
	cpd #6
	blt L75
	.dbline 164
; 			{
; 			 speedl = MAX_LEFT - 85;
	ldd #15
	std _speedl
	.dbline 166
; 			}
; 		}
	bra L75
L74:
	.dbline 170
; 		
; 		else
; 		{
; 			diff = WALL - irdr;
	ldd #105
	subd 20,x
	std 18,x
	.dbline 172
; 			
; 			if(diff >= 1)
	ldd 18,x
	cpd #1
	blt L84
	.dbline 174
; 			{
; 			 speedr = MAX_RIGHT - 25;
	ldd #50
	std _speedr
	.dbline 175
; 			}
L84:
	.dbline 176
; 			if(diff >= 2)
	ldd 18,x
	cpd #2
	blt L86
	.dbline 178
; 			{
; 			 speedr = MAX_RIGHT - 35;
	ldd #40
	std _speedr
	.dbline 179
; 			}
L86:
	.dbline 180
; 			if(diff >= 4)
	ldd 18,x
	cpd #4
	blt L88
	.dbline 182
; 			{
; 			 speedr = MAX_RIGHT - 55;
	ldd #20
	std _speedr
	.dbline 183
; 			}
L88:
	.dbline 184
; 			if(diff >= 6)
	ldd 18,x
	cpd #6
	blt L90
	.dbline 186
; 			{
; 			 speedr = MAX_RIGHT - 65;
	ldd #10
	std _speedr
	.dbline 187
; 			}
L90:
	.dbline 188
; 		}
L75:
	.dbline 191
; 		
; 		
; 		if ((irdc >= STOP) & (irdr >= WALL) & (irdl >= WALL))
	ldd 14,x
	cpd #123
	blt L97
	ldd #1
	std 12,x
	bra L98
L97:
	ldd #0
	std 12,x
L98:
	ldd 20,x
	cpd #105
	blt L99
	ldd #1
	std 10,x
	bra L100
L99:
	ldd #0
	std 10,x
L100:
	ldd 16,x
	cpd #105
	blt L101
	ldd #1
	std 8,x
	bra L102
L101:
	ldd #0
	std 8,x
L102:
	ldd 12,x
	anda 10,x
	andb 11,x
	anda 8,x
	andb 9,x
	cpd #0
	beq L92
	.dbline 193
; 		{
; 			TURN_AROUND();
	jsr _TURN_AROUND
	.dbline 194
; 		}
L92:
	.dbline 196
; 		
; 		if((irdr < IR_MIN + 1) & (irdc < IR_MIN + 1) & (irdl < IR_MIN + 1))
	ldd 20,x
	cpd #89
	bge L108
	ldd #1
	std 6,x
	bra L109
L108:
	ldd #0
	std 6,x
L109:
	ldd 14,x
	cpd #89
	bge L110
	ldd #1
	std 4,x
	bra L111
L110:
	ldd #0
	std 4,x
L111:
	ldd 16,x
	cpd #89
	bge L112
	ldd #1
	std 2,x
	bra L113
L112:
	ldd #0
	std 2,x
L113:
	ldd 6,x
	anda 4,x
	andb 5,x
	anda 2,x
	andb 3,x
	cpd #0
	beq L103
	.dbline 198
; 		{
; 			motorp(RIGHT_MOTOR,0);
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 199
; 			motorp(LEFT_MOTOR,0);
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 200
; 			speedr=0;
	ldd #0
	std _speedr
	.dbline 201
; 			speedl=0;
	ldd #0
	std _speedl
	.dbline 202
; 			done=1;
	ldd #1
	std _done
	.dbline 203
; 		}
L103:
	.dbline 205
; 				 
; 		if(FRONT_BUMP)
	ldd #0
	jsr _analog
	cpd #38
	ble L114
	ldd #0
	jsr _analog
	cpd #120
	bge L114
	.dbline 207
; 		{
; 			speedr=-MAX_RIGHT;
	ldd #-75
	std _speedr
	.dbline 208
; 			speedl=-MAX_LEFT;
	ldd #-100
	std _speedl
	.dbline 209
; 			motorp(RIGHT_MOTOR, speedr);
	ldd _speedr
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 210
; 			motorp(LEFT_MOTOR, speedl);
	ldd _speedl
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 211
; 			wait(5 * DELAY_TIME);
	ldd #125
	jsr _wait
	.dbline 213
; 			
; 		}
L114:
	.dbline 215
	ldd _speedr
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 216
	ldd _speedl
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 217
	ldd #25
	jsr _wait
	.dbline 218
L72:
	.dbline 136
	ldd _done
	bne X0
	jmp L71
X0:
	.dbline 219
; 				
; 		motorp(RIGHT_MOTOR, speedr);
; 		motorp(LEFT_MOTOR, speedl);
; 		wait(DELAY_TIME);
; 	}
; }
L67:
	xgdx
	addd #22
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
_TURN_AROUND::
	.dbfunc TURN_AROUND
	.dbline 224
; 	
; 
; void TURN_AROUND(void)
; {
; 	motorp(RIGHT_MOTOR, -MAX_RIGHT);
	ldd #-75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 225
; 	motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 226
; 	wait(TURN_AROUND_DELAY);
	ldd #800
	jsr _wait
	.dbline 227
; 	speedr = MAX_RIGHT;
	ldd #75
	std _speedr
	.dbline 228
; 	speedl = MAX_LEFT;
	ldd #100
	std _speedl
	.dbline 230
; 
; }
L116:
	rts
;  IX -> 0,x
;  rMEM -> 2,x
;  func temp: 4,x - 8,x
;          ?temp -> 8,x
;          ?temp -> 10,x
;          ?temp -> 12,x
;          ?temp -> 14,x
;          ?temp -> 16,x
;          ?temp -> 18,x
;          ?temp -> 20,x
;          ?temp -> 22,x
;          ?temp -> 24,x
;          ?temp -> 26,x
;          ?temp -> 28,x
;          ?temp -> 30,x
;           diff -> 32,x
;            std -> 34,x
;           irdc -> 36,x
;           irdl -> 38,x
;           irdr -> 40,x
_second::
	jsr __enterb
	.byte 0x2a
	.dbfunc second
	.dbline 239
; 
; void second(void)
; /****************************** Main ***********************************/
; {
; 	int irdr, irdl, irdc;
; 	int std;
; 	int diff;
; 		
; 	init_analog();
	jsr _init_analog
	.dbline 240
; 	init_motortjp();
	jsr _init_motortjp
	.dbline 241
; 	init_clocktjp();
	jsr _init_clocktjp
	.dbline 242
; 	init_PA();
	jsr _init_PA
	.dbline 244
; 
; 	IRE_ON;
	ldab #7
	stab 0x7000
	.dbline 246
; 
; 	speedr = MAX_RIGHT;
	ldd #75
	std _speedr
	.dbline 247
; 	speedl = MAX_LEFT;
	ldd #100
	std _speedl
	.dbline 249
; 	
; 	done=0;
	ldd #0
	std _done
L118:
	.dbline 251
; 
; 	START;
L119:
	ldd #0
	jsr _analog
	cpd #120
	blt L118
	.dbline 253
; 	
; 	std = (RIGHT_IR + LEFT_IR) / 2;
	ldd #2
	jsr _analog
	std 4,x
	ldd #3
	jsr _analog
	std 6,x
	ldd 4,x
	addd 6,x
	ldy #2
	jsr __divi
	std 34,x
	jmp L122
L121:
	.dbline 257
; 
; 	while(done==0)
; 	{
; 		irdl=LEFT_IR;
	ldd #3
	jsr _analog
	std 38,x
	.dbline 258
; 		irdr=RIGHT_IR;
	ldd #2
	jsr _analog
	std 40,x
	.dbline 259
; 		irdc=CENTER_IR;
	ldd #7
	jsr _analog
	std 36,x
	.dbline 261
; 
; 		if ((irdr <= NOWALL2) & ((irdc >= WALL2) | (irdl >= WALL2)))
	ldd 40,x
	cpd #96
	bgt L129
	ldd #1
	std 30,x
	bra L130
L129:
	ldd #0
	std 30,x
L130:
	ldd 36,x
	cpd #100
	blt L131
	ldd #1
	std 28,x
	bra L132
L131:
	ldd #0
	std 28,x
L132:
	ldd 38,x
	cpd #100
	blt L133
	ldd #1
	std 26,x
	bra L134
L133:
	ldd #0
	std 26,x
L134:
	ldd 28,x
	oraa 26,x
	orab 27,x
	std 2,x
	ldd 30,x
	anda 2,x
	andb 3,x
	cpd #0
	beq L124
	.dbline 263
; 		{
; 			TURN_RIGHT();
	jsr _TURN_RIGHT
	.dbline 264
; 		}
	jmp L125
L124:
	.dbline 265
; 		else if ((irdl <= NOWALL2) & ((irdc >= WALL2) | (irdr >= WALL2)))
	ldd 38,x
	cpd #96
	bgt L140
	ldd #1
	std 24,x
	bra L141
L140:
	ldd #0
	std 24,x
L141:
	ldd 36,x
	cpd #100
	blt L142
	ldd #1
	std 22,x
	bra L143
L142:
	ldd #0
	std 22,x
L143:
	ldd 40,x
	cpd #100
	blt L144
	ldd #1
	std 20,x
	bra L145
L144:
	ldd #0
	std 20,x
L145:
	ldd 22,x
	oraa 20,x
	orab 21,x
	std 2,x
	ldd 24,x
	anda 2,x
	andb 3,x
	cpd #0
	beq L135
	.dbline 267
; 		{
; 			TURN_LEFT();
	jsr _TURN_LEFT
	.dbline 268
; 		}
	bra L136
L135:
	.dbline 269
; 		else if ((irdc >= STOP) & (irdr >= WALL2) & (irdl >= WALL2))
	ldd 36,x
	cpd #123
	blt L151
	ldd #1
	std 18,x
	bra L152
L151:
	ldd #0
	std 18,x
L152:
	ldd 40,x
	cpd #100
	blt L153
	ldd #1
	std 16,x
	bra L154
L153:
	ldd #0
	std 16,x
L154:
	ldd 38,x
	cpd #100
	blt L155
	ldd #1
	std 14,x
	bra L156
L155:
	ldd #0
	std 14,x
L156:
	ldd 18,x
	anda 16,x
	andb 17,x
	anda 14,x
	andb 15,x
	cpd #0
	beq L146
	.dbline 271
; 		{
; 			TURN_AROUND();
	jsr _TURN_AROUND
	.dbline 272
; 		}
L146:
L136:
L125:
	.dbline 274
; 		
; 		if((irdr < IR_MIN + 1) & (irdc < IR_MIN + 1) & (irdl < IR_MIN + 1))
	ldd 40,x
	cpd #89
	bge L162
	ldd #1
	std 12,x
	bra L163
L162:
	ldd #0
	std 12,x
L163:
	ldd 36,x
	cpd #89
	bge L164
	ldd #1
	std 10,x
	bra L165
L164:
	ldd #0
	std 10,x
L165:
	ldd 38,x
	cpd #89
	bge L166
	ldd #1
	std 8,x
	bra L167
L166:
	ldd #0
	std 8,x
L167:
	ldd 12,x
	anda 10,x
	andb 11,x
	anda 8,x
	andb 9,x
	cpd #0
	beq L157
	.dbline 276
; 		{
; 			motorp(RIGHT_MOTOR,0);
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 277
; 			motorp(LEFT_MOTOR,0);
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 278
; 			speedr=0;
	ldd #0
	std _speedr
	.dbline 279
; 			speedl=0;
	ldd #0
	std _speedl
	.dbline 280
; 			done=1;
	ldd #1
	std _done
	.dbline 281
; 		}			 
L157:
	.dbline 283
; 
; 		if(FRONT_BUMP)
	ldd #0
	jsr _analog
	cpd #38
	ble L168
	ldd #0
	jsr _analog
	cpd #120
	bge L168
	.dbline 285
; 		{
; 			speedr=-MAX_RIGHT;
	ldd #-75
	std _speedr
	.dbline 286
; 			speedl=-MAX_LEFT;
	ldd #-100
	std _speedl
	.dbline 287
; 			motorp(RIGHT_MOTOR, speedr);
	ldd _speedr
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 288
; 			motorp(LEFT_MOTOR, speedl);
	ldd _speedl
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 289
; 			wait(5 * DELAY_TIME);
	ldd #125
	jsr _wait
	.dbline 290
; 		}
L168:
	.dbline 292
	ldd _speedr
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 293
	ldd _speedl
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 294
	ldd #25
	jsr _wait
	.dbline 295
L122:
	.dbline 255
	ldd _done
	bne X1
	jmp L121
X1:
	.dbline 296
; 				
; 		motorp(RIGHT_MOTOR, speedr);
; 		motorp(LEFT_MOTOR, speedl);
; 		wait(DELAY_TIME);
; 	}
; }
L117:
	xgdx
	addd #42
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
_TURN_RIGHT::
	.dbfunc TURN_RIGHT
	.dbline 301
; 
; void TURN_RIGHT(void)
; {
; 
; 			PA_ON();
	jsr _PA_ON
	.dbline 302
; 			counter=1;
	ldd #1
	std _counter
	.dbline 303
; 			PACNT=PAV_STRAIGHT;
	ldab #128
	stab 0x1027
	.dbline 304
; 			done=0;
	ldd #0
	std _done
	.dbline 306
; 			
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 307
; 			motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L172
L171:
		NOP

	.dbline 311
L172:
	.dbline 308
; 			while(done==0)
	ldd _done
	beq L171
	.dbline 312
; 			{
; 				asm("NOP");
; 			}
; 			counter=1;
	ldd #1
	std _counter
	.dbline 313
; 			PACNT = PAV_TURN;			
	ldab #64
	stab 0x1027
	.dbline 314
; 			done=0;
	ldd #0
	std _done
	.dbline 315
; 			motorp(RIGHT_MOTOR, 0);
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 316
; 			motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L175
L174:
		NOP

	.dbline 320
L175:
	.dbline 317
; 			while(done==0)
	ldd _done
	beq L174
	.dbline 322
; 			{
; 				asm("NOP");
; 			}
; 
; 			counter=1;
	ldd #1
	std _counter
	.dbline 324
; //			PACNT = PAV_STRAIGHT;
; 			PACNT = 0xFF;
	ldab #255
	stab 0x1027
	.dbline 325
; 			done=0;			
	ldd #0
	std _done
	.dbline 326
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 327
; 			motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L178
L177:
		NOP

	.dbline 331
L178:
	.dbline 328
; 			while(done==0)
	ldd _done
	beq L177
	.dbline 333
; 			{
; 				asm("NOP");
; 			}
; 
; 			motorp(RIGHT_MOTOR, 0);
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 334
; 			motorp(LEFT_MOTOR, 0);
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 335
; 			PA_OFF();
	jsr _PA_OFF
	.dbline 336
; }
L170:
	rts
;  IX -> 0,x
_TURN_LEFT::
	.dbfunc TURN_LEFT
	.dbline 342
; 
; 
; 
; void TURN_LEFT(void)
; {
; 			PA_ON();
	jsr _PA_ON
	.dbline 343
; 			counter=1;
	ldd #1
	std _counter
	.dbline 344
; 			PACNT=PAV_STRAIGHT;
	ldab #128
	stab 0x1027
	.dbline 345
; 			done=0;
	ldd #0
	std _done
	.dbline 347
; 			
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 348
; 			motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L182
L181:
		NOP

	.dbline 352
L182:
	.dbline 349
; 			while(done==0)
	ldd _done
	beq L181
	.dbline 354
; 			{
; 				asm("NOP");
; 			}
; 
; 			counter=1;
	ldd #1
	std _counter
	.dbline 355
; 			PACNT = PAV_TURN;			
	ldab #64
	stab 0x1027
	.dbline 356
; 			done=0;
	ldd #0
	std _done
	.dbline 357
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 358
; 			motorp(LEFT_MOTOR, 0);
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L185
L184:
		NOP

	.dbline 362
L185:
	.dbline 359
; 			while(done==0)
	ldd _done
	beq L184
	.dbline 364
; 			{
; 				asm("NOP");
; 			}
; 			
; 			counter=1;
	ldd #1
	std _counter
	.dbline 366
; //			PACNT = PAV_STRAIGHT;
; 			PACNT = 0xFF;
	ldab #255
	stab 0x1027
	.dbline 367
; 			done=0;			
	ldd #0
	std _done
	.dbline 368
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 369
; 			motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L188
L187:
		NOP

	.dbline 373
L188:
	.dbline 370
; 			while(done==0)
	ldd _done
	beq L187
	.dbline 375
; 			{
; 				asm("NOP");
; 			}
; 		
; 			motorp(RIGHT_MOTOR, 0);
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 376
; 			motorp(LEFT_MOTOR, 0);
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 377
; 			PA_OFF();
	jsr _PA_OFF
	.dbline 378
; }
L180:
	rts
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 383
; 
; 
; void PAV_isr(void)
; {
; 	if(counter==0)
	ldd _counter
	bne L191
	.dbline 385
; 	{
; 		motorp(RIGHT_MOTOR,0);
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 386
; 		motorp(LEFT_MOTOR,0);
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 387
; 		done=1;
	ldd #1
	std _done
	.dbline 388
; 	}
	bra L192
L191:
	.dbline 391
; 	else
; 	{
; 		counter--;
	ldd _counter
	subd #1
	std _counter
	.dbline 392
; 	}
L192:
	.dbline 393
; 	CLEAR_FLAG(TFLG2, 0x20);
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 394
; }
L190:
	rti
;  IX -> 0,x
_init_PA::
			sei

	.dbfunc init_PA
	.dbline 400
; 
; void init_PA(void)
; {
; 	INTR_OFF();
; 
; 	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
	ldy #0x1026
	bclr 0,y,#0xb0
	.dbline 401
; 	CLEAR_BIT(PACTL, 0x40); /*Disable PA*/
	ldy #0x1026
	bclr 0,y,#0x40
	.dbline 404
; 	
; 
; 	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 405
; 	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */
	ldy #0x1024
	bset 0,y,#32
	.dbline 407
; 
; 	PACNT=0x00;
	clr 0x1027
			cli

	.dbline 410
; 
; 	INTR_ON();
; }
L193:
	rts
;  IX -> 0,x
_PA_ON::
			sei

	.dbfunc PA_ON
	.dbline 415
; 
; void PA_ON(void)
; {
; 	INTR_OFF();
; 	SET_BIT(PACTL, 0x40); // Enable PA
	ldy #0x1026
	bset 0,y,#64
			cli

	.dbline 417
; 	INTR_ON();
; }
L194:
	rts
;  IX -> 0,x
_PA_OFF::
			sei

	.dbfunc PA_OFF
	.dbline 422
; 
; void PA_OFF(void)
; {
; 	INTR_OFF();
; 	CLEAR_BIT(PACTL, 0x40); // Disable PA
	ldy #0x1026
	bclr 0,y,#0x40
			cli

	.dbline 424
; 	INTR_ON();
; }
L195:
	rts
;  IX -> 0,x
;  rMEM -> 2,x
;  func temp: 4,x - 8,x
;          ?temp -> 8,x
;          ?temp -> 10,x
;          ?temp -> 12,x
;          ?temp -> 14,x
;          ?temp -> 16,x
;          ?temp -> 18,x
;          ?temp -> 20,x
;          ?temp -> 22,x
;          ?temp -> 24,x
;          ?temp -> 26,x
;          ?temp -> 28,x
;          ?temp -> 30,x
;           diff -> 32,x
;            std -> 34,x
;           done -> 36,x
;           irdc -> 38,x
;           irdl -> 40,x
;           irdr -> 42,x
_third::
	jsr __enterb
	.byte 0x2c
	.dbfunc third
	.dbline 434
; 
; void third(void)
; {
; 	int irdr, irdl, irdc;
; 	int std;
; 	int diff;
; 	int done;
; 	
; 	
; 	init_analog();
	jsr _init_analog
	.dbline 435
; 	init_motortjp();
	jsr _init_motortjp
	.dbline 436
; 	init_clocktjp();
	jsr _init_clocktjp
	.dbline 437
; 	init_PA();
	jsr _init_PA
	.dbline 439
; 
; 	IRE_ON;
	ldab #7
	stab 0x7000
	.dbline 441
; 
; 	speedr = MAX_RIGHT;
	ldd #75
	std _speedr
	.dbline 442
; 	speedl = MAX_LEFT;
	ldd #100
	std _speedl
	.dbline 444
; 	
; 	done=0;	
	ldd #0
	std 36,x
L197:
	.dbline 446
; 
; 	START;
L198:
	ldd #0
	jsr _analog
	cpd #120
	blt L197
	jmp L201
L200:
	.dbline 451
; 	
; 	while(done==0)
; 	{
; 
; 		std = (RIGHT_IR + LEFT_IR) / 2;
	ldd #2
	jsr _analog
	std 4,x
	ldd #3
	jsr _analog
	std 6,x
	ldd 4,x
	addd 6,x
	ldy #2
	jsr __divi
	std 34,x
	.dbline 453
; 
; 		irdl=LEFT_IR;
	ldd #3
	jsr _analog
	std 40,x
	.dbline 454
; 		irdr=RIGHT_IR;
	ldd #2
	jsr _analog
	std 42,x
	.dbline 455
; 		irdc=CENTER_IR;
	ldd #7
	jsr _analog
	std 38,x
	.dbline 457
; 
; 		if ((irdr <= NOWALL2) & ((irdc >= STOP) | (irdl >= WALL2)))
	ldd 42,x
	cpd #96
	bgt L208
	ldd #1
	std 30,x
	bra L209
L208:
	ldd #0
	std 30,x
L209:
	ldd 38,x
	cpd #123
	blt L210
	ldd #1
	std 28,x
	bra L211
L210:
	ldd #0
	std 28,x
L211:
	ldd 40,x
	cpd #100
	blt L212
	ldd #1
	std 26,x
	bra L213
L212:
	ldd #0
	std 26,x
L213:
	ldd 28,x
	oraa 26,x
	orab 27,x
	std 2,x
	ldd 30,x
	anda 2,x
	andb 3,x
	cpd #0
	beq L203
	.dbline 459
; 		{
; 			TURN_RIGHT();
	jsr _TURN_RIGHT
	.dbline 460
; 			STRAIGHTEN();
	jsr _STRAIGHTEN
	.dbline 461
; 			STRAIGHTEN();
	jsr _STRAIGHTEN
	.dbline 462
; 			STRAIGHTEN();
	jsr _STRAIGHTEN
	.dbline 463
; 			STRAIGHTEN();
	jsr _STRAIGHTEN
	.dbline 464
; 		}
	jmp L204
L203:
	.dbline 465
; 		else if ((irdl <= NOWALL2) & ((irdc >= STOP) | (irdr >= WALL2)))
	ldd 40,x
	cpd #96
	bgt L219
	ldd #1
	std 24,x
	bra L220
L219:
	ldd #0
	std 24,x
L220:
	ldd 38,x
	cpd #123
	blt L221
	ldd #1
	std 22,x
	bra L222
L221:
	ldd #0
	std 22,x
L222:
	ldd 42,x
	cpd #100
	blt L223
	ldd #1
	std 20,x
	bra L224
L223:
	ldd #0
	std 20,x
L224:
	ldd 22,x
	oraa 20,x
	orab 21,x
	std 2,x
	ldd 24,x
	anda 2,x
	andb 3,x
	cpd #0
	beq L214
	.dbline 467
; 		{
; 			TURN_LEFT();
	jsr _TURN_LEFT
	.dbline 468
; 			STRAIGHTEN();
	jsr _STRAIGHTEN
	.dbline 469
; 			STRAIGHTEN();
	jsr _STRAIGHTEN
	.dbline 470
; 			STRAIGHTEN();
	jsr _STRAIGHTEN
	.dbline 471
; 			STRAIGHTEN();
	jsr _STRAIGHTEN
	.dbline 472
; 		}
	bra L215
L214:
	.dbline 473
; 		else if ((irdc >= STOP) & ((irdr >= WALL2) & (irdl >= WALL2)))
	ldd 38,x
	cpd #123
	blt L230
	ldd #1
	std 18,x
	bra L231
L230:
	ldd #0
	std 18,x
L231:
	ldd 42,x
	cpd #100
	blt L232
	ldd #1
	std 16,x
	bra L233
L232:
	ldd #0
	std 16,x
L233:
	ldd 40,x
	cpd #100
	blt L234
	ldd #1
	std 14,x
	bra L235
L234:
	ldd #0
	std 14,x
L235:
	ldd 16,x
	anda 14,x
	andb 15,x
	std 2,x
	ldd 18,x
	anda 2,x
	andb 3,x
	cpd #0
	beq L225
	.dbline 475
; 		{
; 			TURN_AROUND();
	jsr _TURN_AROUND
	.dbline 476
; 			STRAIGHTEN();
	jsr _STRAIGHTEN
	.dbline 477
; 			STRAIGHTEN();
	jsr _STRAIGHTEN
	.dbline 478
; 			STRAIGHTEN();
	jsr _STRAIGHTEN
	.dbline 479
; 			STRAIGHTEN();
	jsr _STRAIGHTEN
	.dbline 480
; 		}
L225:
L215:
L204:
	.dbline 482
; 	
; 		if((irdr < IR_MIN + 1) & (irdc < IR_MIN + 1) & (irdl < IR_MIN + 1))
	ldd 42,x
	cpd #89
	bge L241
	ldd #1
	std 12,x
	bra L242
L241:
	ldd #0
	std 12,x
L242:
	ldd 38,x
	cpd #89
	bge L243
	ldd #1
	std 10,x
	bra L244
L243:
	ldd #0
	std 10,x
L244:
	ldd 40,x
	cpd #89
	bge L245
	ldd #1
	std 8,x
	bra L246
L245:
	ldd #0
	std 8,x
L246:
	ldd 12,x
	anda 10,x
	andb 11,x
	anda 8,x
	andb 9,x
	cpd #0
	beq L236
	.dbline 484
; 		{
; 			motorp(RIGHT_MOTOR,0);
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 485
; 			motorp(LEFT_MOTOR,0);
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 486
; 			speedr=0;
	ldd #0
	std _speedr
	.dbline 487
; 			speedl=0;
	ldd #0
	std _speedl
	.dbline 488
; 			done=1;
	ldd #1
	std 36,x
	.dbline 489
; 		}			 
L236:
	.dbline 491
; 
; 		if(FRONT_BUMP)
	ldd #0
	jsr _analog
	cpd #38
	ble L247
	ldd #0
	jsr _analog
	cpd #120
	bge L247
	.dbline 493
; 		{
; 			speedr=-MAX_RIGHT;
	ldd #-75
	std _speedr
	.dbline 494
; 			speedl=-MAX_LEFT;
	ldd #-100
	std _speedl
	.dbline 495
; 			motorp(RIGHT_MOTOR, speedr);
	ldd _speedr
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 496
; 			motorp(LEFT_MOTOR, speedl);
	ldd _speedl
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 497
; 			wait(5 * DELAY_TIME);
	ldd #125
	jsr _wait
	.dbline 498
; 		}
L247:
	.dbline 500
	ldd _speedr
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 501
	ldd _speedl
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 502
	ldd #25
	jsr _wait
	.dbline 503
L201:
	.dbline 448
	ldd 36,x
	bne X2
	jmp L200
X2:
	.dbline 504
; 				
; 		motorp(RIGHT_MOTOR, speedr);
; 		motorp(LEFT_MOTOR, speedl);
; 		wait(DELAY_TIME);
; 	}
; }
L196:
	xgdx
	addd #44
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;           irdc -> 2,x
;            std -> 4,x
;           diff -> 6,x
;           irdl -> 8,x
;           irdr -> 10,x
_STRAIGHTEN::
	jsr __enterb
	.byte 0xc
	.dbfunc STRAIGHTEN
	.dbline 513
; void STRAIGHTEN(void)
; {
; 
; 	int irdr, irdl, irdc;
; 	int diff, std;
; 	
; //	std=(RIGHT_IR + LEFT_IR) / 2;
; 
; 	std=125;
	ldd #125
	std 4,x
	.dbline 515
; 
; 	irdl=LEFT_IR;
	ldd #3
	jsr _analog
	std 8,x
	.dbline 516
; 	irdr=RIGHT_IR;
	ldd #2
	jsr _analog
	std 10,x
	.dbline 517
; 	irdc=CENTER_IR;
	ldd #7
	jsr _analog
	std 2,x
	.dbline 519
; 		
; 	if (irdr > irdl)
	ldd 10,x
	cpd 8,x
	ble L250
	.dbline 521
; 	{
; 		diff = ((irdr - irdl) * AMOUNT) / (IR_MAX - std);
	ldd 10,x
	subd 8,x
	xgdy
	ldd #300
	jsr __muli
	pshb ; 
	psha ; spill
	ldd #126
	subd 4,x
	xgdy
	pula ; 
	pulb ; reload
	jsr __divi
	std 6,x
	.dbline 522
; 		speedl = MAX_LEFT - diff;
	ldd #100
	subd 6,x
	std _speedl
	.dbline 523
; 	}
L250:
	.dbline 525
; 	
; 	if (irdl > irdr)
	ldd 8,x
	cpd 10,x
	ble L252
	.dbline 527
; 	{
; 		diff = ((irdl - irdr) * AMOUNT) / (IR_MAX - std);
	ldd 8,x
	subd 10,x
	xgdy
	ldd #300
	jsr __muli
	pshb ; 
	psha ; spill
	ldd #126
	subd 4,x
	xgdy
	pula ; 
	pulb ; reload
	jsr __divi
	std 6,x
	.dbline 528
; 		speedr = MAX_RIGHT - diff;
	ldd #75
	subd 6,x
	std _speedr
	.dbline 529
; 	}
L252:
	.dbline 531
; 			
; 	motorp(RIGHT_MOTOR, speedr);
	ldd _speedr
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 532
; 	motorp(LEFT_MOTOR, speedl);
	ldd _speedl
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 533
; 	wait(DELAY_TIME);
	ldd #25
	jsr _wait
	.dbline 534
; }
L249:
	xgdx
	addd #12
	xgdx
	txs
	pulx
	rts
	.area bss
_repeat::
	.blkb 2
_done::
	.blkb 2
_counter::
	.blkb 2
_speedl::
	.blkb 2
_speedr::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
	.area text
L56:
	.byte 'T,'h,'r,'e,'e,10,0
L42:
	.byte 'T,'w,'o,10,0
L31:
	.byte 'O,'n,'e,32,'o,'r,32,'T,'w,'o,10,0
L27:
	.byte 'O,'n,'e,10,0
L20:
	.byte 10,0
