	.module ledtest.c
	.dbfile ledtest.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\spinuzza\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 38
; //battery must be fully charged for it to stop
; 
; /*************************** Includes ********************************/
; #include <tjpbase.h>
; #include <stdio.h>
; /************************ End of Includes ****************************/
; 
; /*************************** Constants ********************************/
; #define AVOID_THRESHOLD 100
; #define IR_MAX 126
; #define IR_MIN 88
; #define MAX_RIGHT 75
; #define MAX_LEFT 100
; #define AMOUNT 300
; #define DELAY_TIME 25
; #define STOP 123
; #define NOWALL 90
; #define WALL 105
; #define STRAIGHT_DELAY 550
; #define TURN_DELAY 850
; #define TURN_AROUND_DELAY 800
; #define ZERO 0x7D
; #define ONE 0x30
; #define TWO 0x6E
; #define THREE 0x7A
; #define FOUR 0x33
; #define FIVE 0x5B
; #define SIX 0x1F
; #define SEVEN 0x70
; #define EIGHT 0x7F
; #define NINE 0x73
; #define DISPLAY *(unsigned char *)(0x5000)
; 
; 
; /************************ End of Constants ****************************/
; #pragma interrupt_handler PAV_isr
; /*************************** Prototypes *********************************/
; void init_PA(void);
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 44
; void PAV_isr(void);
; void TURN_RIGHT(void);
; void TURN_LEFT(void);
; void TURN_AROUND(void);
; void update_LED(void);
; /************************ End of Prototypes *****************************/
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 57
; 
; int speedr, speedl;
; int smallcounter, bigcounter;
; int NUMBERS[10]={0x7D,0X30,0X6E,0X7A,0X33,0X5B,0X1F,0X70,0X7F,0X73};
; 
; /*
; NUMBERS[0]=0x7D;
; NUMBERS[1]=0x30;
; NUMBERS[2]=0x6E;
; NUMBERS[3]=0x7A;
; NUMBERS[4]=0x33;
; NUMBERS[5]=0x5B;
; NUMBERS[6]=0x1F;
L4:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 63
; NUMBERS[7]=0x70;
; NUMBERS[8]=0x7F;
; NUMBERS[9]=0x73;
; */
; 
; /*
L5:
	rti
;  IX -> 0,x
_TOC4_isr::
	.dbfunc TOC4_isr
	.dbline 75
; #define ZERO 0x7D
; #define ONE 0x30
; #define TWO 0x6E
; #define THREE 0x7A
; #define FOUR 0x33
; #define FIVE 0x5B
; #define SIX 0x1F
; #define SEVEN 0x70
; #define EIGHT 0x7F
; #define NINE 0x73
; */
; 
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 81
; 
; void main(void)
; /****************************** Main ***********************************/
; {
; 
; 	init_analog();
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 87
; 	init_motortjp();
; 	init_clocktjp();
; 	init_PA();
; 
; 	DISPLAY=NUMBERS[0];
; 
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 99
; 	speedr = MAX_RIGHT;
; 	speedl = MAX_LEFT;
; 
; 	while(1)
; 	{
; 	motorp(RIGHT_MOTOR, speedr);
; 	motorp(LEFT_MOTOR, speedl);
; 	wait(1000);
; 	}
; 
; }
; 
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 105
; void PAV_isr(void)
; {
; 	CLEAR_FLAG(TFLG2, 0x20);
; 	smallcounter++;
; 	if(smallcounter==5)
; 	{
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 111
; 		smallcounter=0;
; 		bigcounter++;
; 		if(bigcounter == 9)
; 		{
; 			speedr=0;
; 			speedl=0;
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 117
; 		}
; 		DISPLAY=NUMBERS[bigcounter];
; 	}
; }
; 
; void init_PA(void)
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 123
; {
; 	INTR_OFF();
; 
; 	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
; 	SET_BIT(PACTL, 0x40); /*Enable PA*/
; 	
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 129
; 
; 	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
; 	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */
; 
; 	PACNT=0x00;
; 
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 135
; 	INTR_ON();
; }
; 
; 
; void TURN_AROUND(void)
; {
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 141
; 	motorp(RIGHT_MOTOR, MAX_RIGHT);
; 	motorp(LEFT_MOTOR, -MAX_LEFT);
; 	wait(TURN_AROUND_DELAY);
; 	speedr = MAX_RIGHT;
; 	speedl = MAX_LEFT;
; }
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 147
; }
; }
; }
; }
; }
; }
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 153
; }
; }
; }
; }
; }
; }
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area data
_NUMBERS::
	.blkb 2
	.area idata
	.word 125
	.area data
	.blkb 2
	.area idata
	.word 48
	.area data
	.blkb 2
	.area idata
	.word 110
	.area data
	.blkb 2
	.area idata
	.word 122
	.area data
	.blkb 2
	.area idata
	.word 51
	.area data
	.blkb 2
	.area idata
	.word 91
	.area data
	.blkb 2
	.area idata
	.word 31
	.area data
	.blkb 2
	.area idata
	.word 112
	.area data
	.blkb 2
	.area idata
	.word 127
	.area data
	.blkb 2
	.area idata
	.word 115
	.area text
;  IX -> 0,x
_main::
	.dbfile ledtest.c
	.dbfunc main
	.dbline 81
	jsr _init_analog
	.dbline 82
	jsr _init_motortjp
	.dbline 83
	jsr _init_clocktjp
	.dbline 84
	jsr _init_PA
	.dbline 86
	ldd _NUMBERS
	stab 0x5000
	.dbline 88
	ldd #75
	std _speedr
	.dbline 89
	ldd #100
	std _speedl
	bra L21
L20:
	.dbline 93
	ldd _speedr
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 94
	ldd _speedl
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 95
	ldd #1000
	jsr _wait
	.dbline 96
L21:
	.dbline 91
	bra L20
L19:
	rts
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 102
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 103
	ldd _smallcounter
	addd #1
	std _smallcounter
	.dbline 104
	ldd _smallcounter
	cpd #5
	bne L24
	.dbline 106
	ldd #0
	std _smallcounter
	.dbline 107
	ldd _bigcounter
	addd #1
	std _bigcounter
	.dbline 108
	ldd _bigcounter
	cpd #9
	bne L26
	.dbline 110
	ldd #0
	std _speedr
	.dbline 111
	ldd #0
	std _speedl
	.dbline 112
L26:
	.dbline 113
	ldd _bigcounter
	lsld
	addd #_NUMBERS
	xgdy
	ldd 0,y
	stab 0x5000
	.dbline 114
L24:
	.dbline 115
L23:
	rti
;  IX -> 0,x
_init_PA::
			sei

	.dbfunc init_PA
	.dbline 121
	ldy #0x1026
	bclr 0,y,#0xb0
	.dbline 122
	ldy #0x1026
	bset 0,y,#64
	.dbline 125
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 126
	ldy #0x1024
	bset 0,y,#32
	.dbline 128
	clr 0x1027
			cli

	.dbline 131
L28:
	rts
;  IX -> 0,x
_TURN_AROUND::
	.dbfunc TURN_AROUND
	.dbline 136
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 137
	ldd #-100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 138
	ldd #800
	jsr _wait
	.dbline 139
	ldd #75
	std _speedr
	.dbline 140
	ldd #100
	std _speedl
	.dbline 141
L29:
	rts
	.area bss
_bigcounter::
	.blkb 2
_smallcounter::
	.blkb 2
_speedl::
	.blkb 2
_speedr::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
