	.module testwtrn.c
	.dbfile testwtrn.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\spinuzza\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 38
; /*************************** Includes ********************************/
; #include <tjpbase.h>
; #include <stdio.h>
; #include <algconst.h>
; /************************ End of Includes ****************************/
; 
; /*************************** Constants ********************************/
; #define PAV_TURN	0x40
; #define PAV_STRAIGHT 0x80
; 
; /************************ End of Constants ****************************/
; #pragma interrupt_handler PAV_isr
; /*************************** Prototypes *********************************/
; void init_PA(void);
; void PAV_isr(void);
; void TURN_RIGHT(void);
; void TURN_LEFT(void);
; void TURN_AROUND(void);
; void PA_ON(void);
; void PA_OFF(void);
; /************************ End of Prototypes *****************************/
; 
; int counter;
; int speedr;
; int speedl;
; int done;
; 
; 
; void main(void)
; /****************************** Main ***********************************/
; {
; 	int irdr, irdl, irdc;
; 	int std;
; 	int diff;
; 	
; 	
; 	init_analog();
; 	init_motortjp();
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 44
; 	init_clocktjp();
; 	init_PA();
; 
; 	IRE_ON;
; 
; 	speedr = MAX_RIGHT;
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 57
; 	speedl = MAX_LEFT;
; 	
; 	START;
; 	
; 	std = (RIGHT_IR + LEFT_IR) / 2;
; 
; 	while(1)
; 	{
; 		irdl=LEFT_IR;
; 		irdr=RIGHT_IR;
; 		irdc=CENTER_IR;
; 
; 		if ((irdr <= NOWALL) & ((irdc >= WALL) | (irdl >= WALL)))
L4:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 63
; 		{
; 			TURN_RIGHT();
; 		}
; 		else if ((irdl <= NOWALL) & ((irdc >= WALL) | (irdr >= WALL)))
; 		{
; 			TURN_LEFT();
L5:
	rti
;  IX -> 0,x
_TOC4_isr::
	.dbfunc TOC4_isr
	.dbline 75
; 		}
; 		else if ((irdc >= STOP) & (irdr >= WALL) & (irdl >= WALL))
; 		{
; 			TURN_AROUND();
; 		}
; 		
; 		if((irdr < IR_MIN+1) & (irdc < IR_MIN+1) & (irdl < IR_MIN+1))
; 		{
; 			motorp(RIGHT_MOTOR,0);
; 			motorp(LEFT_MOTOR,0);
; 			speedr=MAX_RIGHT;
; 			speedl=MAX_LEFT;
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 81
; 			START;
; 		}			 
; 
; 		if(FRONT_BUMP)
; 		{
; 			speedr=-MAX_RIGHT;
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 87
; 			speedl=-MAX_LEFT;
; 			motorp(RIGHT_MOTOR, speedr);
; 			motorp(LEFT_MOTOR, speedl);
; 			wait(5 * DELAY_TIME);
; 		}
; 				
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 99
; 		motorp(RIGHT_MOTOR, speedr);
; 		motorp(LEFT_MOTOR, speedl);
; 		wait(DELAY_TIME);
; 	}
; }
; 	
; 
; void TURN_RIGHT(void)
; {
; 			PA_ON();
; 			counter=1;
; 			PACNT=PAV_STRAIGHT;
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 105
; 			done=0;
; 			
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
; 			motorp(LEFT_MOTOR, MAX_LEFT);
; 			while(done==0)
; 			{
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 111
; 				asm("NOP");
; 			}
; 			counter=1;
; 			PACNT = PAV_TURN;			
; 			done=0;
; 			motorp(RIGHT_MOTOR, 0);
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 117
; 			motorp(LEFT_MOTOR, MAX_LEFT);
; 			while(done==0)
; 			{
; 				asm("NOP");
; 			}
; 
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 123
; 			counter=1;
; //			PACNT = PAV_STRAIGHT;
; 			PACNT = 0xFF;
; 			done=0;			
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
; 			motorp(LEFT_MOTOR, MAX_LEFT);
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 129
; 			while(done==0)
; 			{
; 				asm("NOP");
; 			}
; 
; 			motorp(RIGHT_MOTOR, 0);
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 135
; 			motorp(LEFT_MOTOR, 0);
; 			PA_OFF();
; }
; 
; 
; 
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 141
; void TURN_LEFT(void)
; {
; 			PA_ON();
; 			counter=1;
; 			PACNT=PAV_STRAIGHT;
; 			done=0;
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 147
; 			
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
; 			motorp(LEFT_MOTOR, MAX_LEFT);
; 			while(done==0)
; 			{
; 				asm("NOP");
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 153
; 			}
; 
; 			counter=1;
; 			PACNT = PAV_TURN;			
; 			done=0;
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area text
;  IX -> 0,x
;  rMEM -> 2,x
;  func temp: 4,x - 8,x
;          ?temp -> 8,x
;          ?temp -> 10,x
;          ?temp -> 12,x
;          ?temp -> 14,x
;          ?temp -> 16,x
;          ?temp -> 18,x
;          ?temp -> 20,x
;          ?temp -> 22,x
;          ?temp -> 24,x
;          ?temp -> 26,x
;          ?temp -> 28,x
;          ?temp -> 30,x
;           diff -> 32,x
;            std -> 34,x
;           irdc -> 36,x
;           irdl -> 38,x
;           irdr -> 40,x
_main::
	jsr __enterb
	.byte 0x2a
	.dbfile testwtrn.c
	.dbfunc main
	.dbline 37
	jsr _init_analog
	.dbline 38
	jsr _init_motortjp
	.dbline 39
	jsr _init_clocktjp
	.dbline 40
	jsr _init_PA
	.dbline 42
	ldab #7
	stab 0x7000
	.dbline 44
	ldd #75
	std _speedr
	.dbline 45
	ldd #100
	std _speedl
L20:
	.dbline 47
L21:
	ldd #0
	jsr _analog
	cpd #120
	blt L20
	.dbline 49
	ldd #2
	jsr _analog
	std 4,x
	ldd #3
	jsr _analog
	std 6,x
	ldd 4,x
	addd 6,x
	ldy #2
	jsr __divi
	std 34,x
	jmp L24
L23:
	.dbline 53
	ldd #3
	jsr _analog
	std 38,x
	.dbline 54
	ldd #2
	jsr _analog
	std 40,x
	.dbline 55
	ldd #7
	jsr _analog
	std 36,x
	.dbline 57
	ldd 40,x
	cpd #95
	bgt L31
	ldd #1
	std 30,x
	bra L32
L31:
	ldd #0
	std 30,x
L32:
	ldd 36,x
	cpd #105
	blt L33
	ldd #1
	std 28,x
	bra L34
L33:
	ldd #0
	std 28,x
L34:
	ldd 38,x
	cpd #105
	blt L35
	ldd #1
	std 26,x
	bra L36
L35:
	ldd #0
	std 26,x
L36:
	ldd 28,x
	oraa 26,x
	orab 27,x
	std 2,x
	ldd 30,x
	anda 2,x
	andb 3,x
	cpd #0
	beq L26
	.dbline 59
	jsr _TURN_RIGHT
	.dbline 60
	jmp L27
L26:
	.dbline 61
	ldd 38,x
	cpd #95
	bgt L42
	ldd #1
	std 24,x
	bra L43
L42:
	ldd #0
	std 24,x
L43:
	ldd 36,x
	cpd #105
	blt L44
	ldd #1
	std 22,x
	bra L45
L44:
	ldd #0
	std 22,x
L45:
	ldd 40,x
	cpd #105
	blt L46
	ldd #1
	std 20,x
	bra L47
L46:
	ldd #0
	std 20,x
L47:
	ldd 22,x
	oraa 20,x
	orab 21,x
	std 2,x
	ldd 24,x
	anda 2,x
	andb 3,x
	cpd #0
	beq L37
	.dbline 63
	jsr _TURN_LEFT
	.dbline 64
	bra L38
L37:
	.dbline 65
	ldd 36,x
	cpd #123
	blt L53
	ldd #1
	std 18,x
	bra L54
L53:
	ldd #0
	std 18,x
L54:
	ldd 40,x
	cpd #105
	blt L55
	ldd #1
	std 16,x
	bra L56
L55:
	ldd #0
	std 16,x
L56:
	ldd 38,x
	cpd #105
	blt L57
	ldd #1
	std 14,x
	bra L58
L57:
	ldd #0
	std 14,x
L58:
	ldd 18,x
	anda 16,x
	andb 17,x
	anda 14,x
	andb 15,x
	cpd #0
	beq L48
	.dbline 67
	jsr _TURN_AROUND
	.dbline 68
L48:
L38:
L27:
	.dbline 70
	ldd 40,x
	cpd #89
	bge L64
	ldd #1
	std 12,x
	bra L65
L64:
	ldd #0
	std 12,x
L65:
	ldd 36,x
	cpd #89
	bge L66
	ldd #1
	std 10,x
	bra L67
L66:
	ldd #0
	std 10,x
L67:
	ldd 38,x
	cpd #89
	bge L68
	ldd #1
	std 8,x
	bra L69
L68:
	ldd #0
	std 8,x
L69:
	ldd 12,x
	anda 10,x
	andb 11,x
	anda 8,x
	andb 9,x
	cpd #0
	beq L59
	.dbline 72
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 73
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 74
	ldd #75
	std _speedr
	.dbline 75
	ldd #100
	std _speedl
L70:
	.dbline 76
L71:
	ldd #0
	jsr _analog
	cpd #120
	blt L70
	.dbline 77
L59:
	.dbline 79
	ldd #0
	jsr _analog
	cpd #38
	ble L73
	ldd #0
	jsr _analog
	cpd #120
	bge L73
	.dbline 81
	ldd #-75
	std _speedr
	.dbline 82
	ldd #-100
	std _speedl
	.dbline 83
	ldd _speedr
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 84
	ldd _speedl
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 85
	ldd #250
	jsr _wait
	.dbline 86
L73:
	.dbline 88
	ldd _speedr
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 89
	ldd _speedl
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 90
	ldd #50
	jsr _wait
	.dbline 91
L24:
	.dbline 51
	jmp L23
L19:
	xgdx
	addd #42
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
_TURN_RIGHT::
	.dbfunc TURN_RIGHT
	.dbline 97
	jsr _PA_ON
	.dbline 98
	ldd #1
	std _counter
	.dbline 99
	ldab #128
	stab 0x1027
	.dbline 100
	ldd #0
	std _done
	.dbline 102
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 103
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L77
L76:
		NOP

	.dbline 107
L77:
	.dbline 104
	ldd _done
	beq L76
	.dbline 108
	ldd #1
	std _counter
	.dbline 109
	ldab #64
	stab 0x1027
	.dbline 110
	ldd #0
	std _done
	.dbline 111
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 112
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L80
L79:
		NOP

	.dbline 116
L80:
	.dbline 113
	ldd _done
	beq L79
	.dbline 118
	ldd #1
	std _counter
	.dbline 120
	ldab #255
	stab 0x1027
	.dbline 121
	ldd #0
	std _done
	.dbline 122
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 123
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L83
L82:
		NOP

	.dbline 127
L83:
	.dbline 124
	ldd _done
	beq L82
	.dbline 129
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 130
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 131
	jsr _PA_OFF
	.dbline 132
L75:
	rts
;  IX -> 0,x
_TURN_LEFT::
	.dbfunc TURN_LEFT
	.dbline 138
	jsr _PA_ON
	.dbline 139
	ldd #1
	std _counter
	.dbline 140
	ldab #128
	stab 0x1027
	.dbline 141
	ldd #0
	std _done
	.dbline 143
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 144
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L87
L86:
		NOP

	.dbline 148
L87:
	.dbline 145
	ldd _done
	beq L86
	.dbline 150
	ldd #1
	std _counter
	.dbline 151
	ldab #64
	stab 0x1027
	.dbline 152
	ldd #0
	std _done
	.dbline 153
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 154
; 			motorp(LEFT_MOTOR, 0);
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L90
L89:
		NOP

	.dbline 158
L90:
	.dbline 155
; 			while(done==0)
	ldd _done
	beq L89
	.dbline 160
; 			{
; 				asm("NOP");
; 			}
; 			
; 			counter=1;
	ldd #1
	std _counter
	.dbline 162
; //			PACNT = PAV_STRAIGHT;
; 			PACNT = 0xFF;
	ldab #255
	stab 0x1027
	.dbline 163
; 			done=0;			
	ldd #0
	std _done
	.dbline 164
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 165
; 			motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L93
L92:
		NOP

	.dbline 169
L93:
	.dbline 166
; 			while(done==0)
	ldd _done
	beq L92
	.dbline 171
; 			{
; 				asm("NOP");
; 			}
; 		
; 			motorp(RIGHT_MOTOR, 0);
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 172
; 			motorp(LEFT_MOTOR, 0);
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 173
; 			PA_OFF();
	jsr _PA_OFF
	.dbline 174
; }
L85:
	rts
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 179
; 
; 
; void PAV_isr(void)
; {
; 	if(counter==0)
	ldd _counter
	bne L96
	.dbline 181
; 	{
; 		motorp(RIGHT_MOTOR,0);
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 182
; 		motorp(LEFT_MOTOR,0);
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 183
; 		done=1;
	ldd #1
	std _done
	.dbline 184
; 	}
	bra L97
L96:
	.dbline 187
; 	else
; 	{
; 		counter--;
	ldd _counter
	subd #1
	std _counter
	.dbline 188
; 	}
L97:
	.dbline 189
; 	CLEAR_FLAG(TFLG2, 0x20);
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 190
; }
L95:
	rti
;  IX -> 0,x
_init_PA::
			sei

	.dbfunc init_PA
	.dbline 196
; 
; void init_PA(void)
; {
; 	INTR_OFF();
; 
; 	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
	ldy #0x1026
	bclr 0,y,#0xb0
	.dbline 197
; 	CLEAR_BIT(PACTL, 0x40); /*Disable PA*/
	ldy #0x1026
	bclr 0,y,#0x40
	.dbline 200
; 	
; 
; 	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 201
; 	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */
	ldy #0x1024
	bset 0,y,#32
	.dbline 203
; 
; 	PACNT=0x00;
	clr 0x1027
			cli

	.dbline 206
; 
; 	INTR_ON();
; }
L98:
	rts
;  IX -> 0,x
_TURN_AROUND::
	.dbfunc TURN_AROUND
	.dbline 211
; 
; 
; void TURN_AROUND(void)
; {
; 	motorp(RIGHT_MOTOR, -MAX_RIGHT);
	ldd #-75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 212
; 	motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 213
; 	wait(TURN_AROUND_DELAY);
	ldd #800
	jsr _wait
	.dbline 214
; 	speedr = MAX_RIGHT;
	ldd #75
	std _speedr
	.dbline 215
; 	speedl = MAX_LEFT;
	ldd #100
	std _speedl
	.dbline 216
; }
L99:
	rts
;  IX -> 0,x
_PA_ON::
			sei

	.dbfunc PA_ON
	.dbline 221
; 
; void PA_ON(void)
; {
; 	INTR_OFF();
; 	SET_BIT(PACTL, 0x40); // Enable PA
	ldy #0x1026
	bset 0,y,#64
			cli

	.dbline 223
; 	INTR_ON();
; }
L100:
	rts
;  IX -> 0,x
_PA_OFF::
			sei

	.dbfunc PA_OFF
	.dbline 228
; 
; void PA_OFF(void)
; {
; 	INTR_OFF();
; 	CLEAR_BIT(PACTL, 0x40); // Disable PA
	ldy #0x1026
	bclr 0,y,#0x40
			cli

	.dbline 230
; 	INTR_ON();
; }
L101:
	rts
	.area bss
_done::
	.blkb 2
_speedl::
	.blkb 2
_speedr::
	.blkb 2
_counter::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
