	.module mousetst.c
	.dbfile mousetst.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\ICCTJP\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 38
; /************************************************************************
;  * 			MEKATRONIX Copyright 1998 		        *
;  * Title        avoidtjp.c                                              *
;  * Programmer	Keith L. Doty and modified for IC by Scott Jantz     	*
;  * Date         August 25, 1998                                         *
;  * Version	1			                		*
;  *								        *
;  * Description								*
;  *    A very simple collision avoidance program. TJ PRO will read 	*
;  *    each IR detectors, and turn away from any obstacles in its	*
;  *    path. Also, if something hits TJ PRO's bumper, it will back up,	*
;  *    turn, and go on.							*
;  *			                                                *     					*
;  ************************************************************************/
;  
; 
; /*************************** Includes ********************************/
; 
; #include <tjpbase.h>
; #include <stdio.h>
; #include <pa.h>
; 
; /************************ End of Includes ****************************/
; 
; 
; /*************************** Constants ********************************/
; 
; #define AVOID_THRESHOLD 100
; 
; /************************ End of Constants ****************************/
; #pragma interrupt_handler PAV_isr
; 
; 
; /*************************** Prototypes *********************************/
; void turn(void);
; void PAV_isr(void);
; /************************ End of Prototypes *****************************/
; 
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 44
; int counter;
; int speedr;
; int speedl;
; 
; void main(void)
; /****************************** Main ***********************************/
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 57
; {
; 
; 	init_analog();
; 	init_motortjp();
; 	init_clocktjp();
; 	init_PA();
; 
; 	START;
; 	
; 	speedr=100;
; 	speedl=100;
; 	
; 	while(1)
L4:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 63
; 	{
; 		motorp(RIGHT_MOTOR, speedr);
; 		motorp(LEFT_MOTOR, speedl);
; 		wait(35);
; 	}
; }
L5:
	rti
;  IX -> 0,x
_TOC4_isr::
	.dbfunc TOC4_isr
	.dbline 75
; 	
; 
; void PAV_isr(void)
; {
; 	counter=counter+1;
; 	if (counter=10)
; 	{
; 	 speedr=0;
; 	 speedl=0;
; 	}
; 	CLEAR_FLAG(TFLG2, 0x20);
; }
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 81
; }
; }
; }
; }
; }
; }
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 87
; }
; }
; }
; }
; }
; }
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 99
; }
; }
; }
; }
; }
; }
; }
; }
; }
; }
; }
; }
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 105
; }
; }
; }
; }
; }
; }
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 111
; }
; }
; }
; }
; }
; }
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 117
; }
; }
; }
; }
; }
; }
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 123
; }
; }
; }
; }
; }
; }
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 129
; }
; }
; }
; }
; }
; }
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 135
; }
; }
; }
; }
; }
; }
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 141
; }
; }
; }
; }
; }
; }
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 147
; }
; }
; }
; }
; }
; }
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 153
; }
; }
; }
; }
; }
; }
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area text
;  IX -> 0,x
_init_PA::
	.dbfile C:\ICCTJP\include/pa.h
	.dbfunc init_PA
	.dbline 6
	ldy #0x1026
	bclr 0,y,#0xb0
	.dbline 7
	ldy #0x1026
	bset 0,y,#64
	.dbline 10
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 11
	ldy #0x1024
	bset 0,y,#32
	.dbline 12
L19:
	rts
;  IX -> 0,x
_main::
	.dbfile mousetst.c
	.dbfunc main
	.dbline 47
	jsr _init_analog
	.dbline 48
	jsr _init_motortjp
	.dbline 49
	jsr _init_clocktjp
	.dbline 50
	jsr _init_PA
L21:
	.dbline 52
L22:
	ldd #0
	jsr _analog
	cpd #120
	blt L21
	.dbline 54
	ldd #100
	std _speedr
	.dbline 55
	ldd #100
	std _speedl
	bra L25
L24:
	.dbline 59
	ldd _speedr
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 60
	ldd _speedl
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 61
	ldd #35
	jsr _wait
	.dbline 62
L25:
	.dbline 57
	bra L24
L20:
	rts
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 68
	ldd _counter
	addd #1
	std _counter
	.dbline 69
	ldd #10
	std _counter
	tst #10
	beq L28
	.dbline 71
	ldd #0
	std _speedr
	.dbline 72
	ldd #0
	std _speedl
	.dbline 73
L28:
	.dbline 74
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 75
L27:
	rti
	.area bss
_speedl::
	.blkb 2
_speedr::
	.blkb 2
_counter::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
