	.module square.c
	.dbfile square.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\ICCTJP\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 38
; #include <stdio.h>
; #include <tjpbase.h>
; 
; #pragma interrupt_handler PAV_isr
; 
; void init_PA(void);
; void PAV_isr(void);
; 
; void main(void)
; {
; 	int irdl, irdr, avl, avr, speedr, speedl, templ, tempr, NotDone;
; 	int irl[5], irr[5];
; 
; 	int i;
; 
; 	init_analog();
; 	init_motortjp();
; 	init_clocktjp();
; 	init_PA();
; 
; 	IRE_ON;
; 
; 	START;
; 
; 	for(i=0; i<6; i++)
; 	{
; 		irr[i]=RIGHT_IR;
; 		irl[i]=LEFT_IR;
; 	}
; 	
; 	avl=0;
; 	avr=0;
; 	
; 	for(i=0; i<6; i++)
; 	{
; 		avr=avr+irr[i];
; 		avl=avl+irl[i];
; 	}
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 44
; 	avr=avr/6; // Standard right reading
; 	avl=avl/6; // Standard left reading;
; 
; 	speedr=100;
; 	speedl=100;
; 	
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 57
; 	while(1)
; 	{
; 
; 	while (NotDone=0)
; 	{
; 		irdr=RIGHT_IR;
; 		irdl=LEFT_IR;
; 	 
; 		if (irdr > avr & irdl < avl)
; 			speedl=speedl-1;
; 	 
; 		if (irdr < avr & irdl > avl)
; 			speedr=speedr-1;
L4:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 63
; 	 
; 		if (irdr > avr & irdl > avl)
; 		{
; 			tempr=speedr;
; 			templ=speedl;
; 			speedr=0;
L5:
	rti
;  IX -> 0,x
_TOC4_isr::
	.dbfunc TOC4_isr
	.dbline 75
; 			speedl=0;
; 			NotDone=1;
; 		}
; 		motorp(RIGHT_MOTOR, speedr);
; 		motorp(LEFT_MOTOR, speedl);
; 		wait (35);
; 	}
; 	START;
; 	NotDone=0;
; 	}
; }
; 
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 81
; 
; void init_PA(void)
; {
; 	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
; 	SET_BIT(PACTL, 0x40); /*Enable PA*/
; 	
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 87
; 
; 	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
; 	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */
; 
; 	INTR_ON();
; }
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 99
; 
; void PAV_isr(void)
; {
; 	CLEAR_FLAG(TFLG2, 0x20);
; }
; }
; }
; }
; }
; }
; }
; }
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 105
; }
; }
; }
; }
; }
; }
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 111
; }
; }
; }
; }
; }
; }
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 117
; }
; }
; }
; }
; }
; }
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 123
; }
; }
; }
; }
; }
; }
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 129
; }
; }
; }
; }
; }
; }
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 135
; }
; }
; }
; }
; }
; }
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 141
; }
; }
; }
; }
; }
; }
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 147
; }
; }
; }
; }
; }
; }
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 153
; }
; }
; }
; }
; }
; }
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area text
;  IX -> 0,x
;  rMEM -> 2,x
;  func temp: 4,x - 8,x
;          ?temp -> 8,x
;          ?temp -> 10,x
;          ?temp -> 12,x
;          ?temp -> 14,x
;          ?temp -> 16,x
;          ?temp -> 18,x
;            irr -> 20,x
;            irl -> 30,x
;          tempr -> 40,x
;          templ -> 42,x
;              i -> 44,x
;        NotDone -> 46,x
;         speedl -> 48,x
;         speedr -> 50,x
;            avr -> 52,x
;            avl -> 54,x
;           irdr -> 56,x
;           irdl -> 58,x
_main::
	jsr __enterb
	.byte 0x3c
	.dbfile square.c
	.dbfunc main
	.dbline 16
	jsr _init_analog
	.dbline 17
	jsr _init_motortjp
	.dbline 18
	jsr _init_clocktjp
	.dbline 19
	jsr _init_PA
	.dbline 21
	ldab #7
	stab 0x7000
L20:
	.dbline 23
L21:
	ldd #0
	jsr _analog
	cpd #120
	blt L20
	.dbline 25
	ldd #0
	std 44,x
L23:
	.dbline 27
	ldd #2
	jsr _analog
	std 4,x
	ldd 0,x
	addd #20
	std 2,x
	ldd 44,x
	lsld
	addd 2,x
	xgdy
	ldd 4,x
	std 0,y
	.dbline 28
	ldd #3
	jsr _analog
	std 6,x
	ldd 0,x
	addd #30
	std 2,x
	ldd 44,x
	lsld
	addd 2,x
	xgdy
	ldd 6,x
	std 0,y
	.dbline 29
L24:
	ldd 44,x
	addd #1
	std 44,x
	cpd #6
	blt L23
	.dbline 31
	ldd #0
	std 54,x
	.dbline 32
	ldd #0
	std 52,x
	.dbline 34
	ldd #0
	std 44,x
L27:
	.dbline 36
	ldd 0,x
	addd #20
	std 2,x
	ldd 44,x
	lsld
	addd 2,x
	xgdy
	ldd 52,x
	addd 0,y
	std 52,x
	.dbline 37
	ldd 0,x
	addd #30
	std 2,x
	ldd 44,x
	lsld
	addd 2,x
	xgdy
	ldd 54,x
	addd 0,y
	std 54,x
	.dbline 38
L28:
	ldd 44,x
	addd #1
	std 44,x
	cpd #6
	blt L27
	.dbline 39
	ldd 52,x
	ldy #6
	jsr __divi
	std 52,x
	.dbline 40
	ldd 54,x
	ldy #6
	jsr __divi
	std 54,x
	.dbline 42
	ldd #100
	std 50,x
	.dbline 43
	ldd #100
	std 48,x
	jmp L32
L34:
	.dbline 50
	ldd #2
	jsr _analog
	std 56,x
	.dbline 51
	ldd #3
	jsr _analog
	std 58,x
	.dbline 53
	ldd 56,x
	cpd 52,x
	ble L41
	ldd #1
	std 18,x
	bra L42
L41:
	ldd #0
	std 18,x
L42:
	ldd 58,x
	cpd 54,x
	bge L43
	ldd #1
	std 16,x
	bra L44
L43:
	ldd #0
	std 16,x
L44:
	ldd 18,x
	anda 16,x
	andb 17,x
	cpd #0
	beq L37
	.dbline 54
	ldd 48,x
	subd #1
	std 48,x
L37:
	.dbline 56
	ldd 56,x
	cpd 52,x
	bge L49
	ldd #1
	std 14,x
	bra L50
L49:
	ldd #0
	std 14,x
L50:
	ldd 58,x
	cpd 54,x
	ble L51
	ldd #1
	std 12,x
	bra L52
L51:
	ldd #0
	std 12,x
L52:
	ldd 14,x
	anda 12,x
	andb 13,x
	cpd #0
	beq L45
	.dbline 57
	ldd 50,x
	subd #1
	std 50,x
L45:
	.dbline 59
	ldd 56,x
	cpd 52,x
	ble L57
	ldd #1
	std 10,x
	bra L58
L57:
	ldd #0
	std 10,x
L58:
	ldd 58,x
	cpd 54,x
	ble L59
	ldd #1
	std 8,x
	bra L60
L59:
	ldd #0
	std 8,x
L60:
	ldd 10,x
	anda 8,x
	andb 9,x
	cpd #0
	beq L53
	.dbline 61
	ldd 50,x
	std 40,x
	.dbline 62
	ldd 48,x
	std 42,x
	.dbline 63
	ldd #0
	std 50,x
	.dbline 64
	ldd #0
	std 48,x
	.dbline 65
	ldd #1
	std 46,x
	.dbline 66
L53:
	.dbline 67
	ldd 50,x
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 68
	ldd 48,x
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 69
	ldd #35
	jsr _wait
	.dbline 70
L35:
	.dbline 48
	ldd #0
	std 46,x
	tst #0
	beq X0
	jmp L34
X0:
L61:
	.dbline 71
L62:
	ldd #0
	jsr _analog
	cpd #120
	blt L61
	.dbline 72
	ldd #0
	std 46,x
	.dbline 73
L32:
	.dbline 45
	bra L35
L19:
	xgdx
	addd #60
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
_init_PA::
	.dbfunc init_PA
	.dbline 79
	ldy #0x1026
	bclr 0,y,#0xb0
	.dbline 80
	ldy #0x1026
	bset 0,y,#64
	.dbline 83
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 84
	ldy #0x1024
	bset 0,y,#32
			cli

	.dbline 87
L64:
	rts
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 91
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 92
L65:
	rti
	.area bss
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
