#include <stdio.h>
#include <tjpbase.h>

#pragma interrupt_handler PAV_isr

void init_PA(void);
void PAV_isr(void);

void main(void)
{
	int irdl, irdr, avl, avr, speedr, speedl, templ, tempr, NotDone;
	int irl[5], irr[5];

	int i;

	init_analog();
	init_motortjp();
	init_clocktjp();
	init_PA();

	IRE_ON;

	START;

	for(i=0; i<6; i++)
	{
		irr[i]=RIGHT_IR;
		irl[i]=LEFT_IR;
	}
	
	avl=0;
	avr=0;
	
	for(i=0; i<6; i++)
	{
		avr=avr+irr[i];
		avl=avl+irl[i];
	}
	avr=avr/6; // Standard right reading
	avl=avl/6; // Standard left reading;

	speedr=100;
	speedl=100;
	
	while(1)
	{

	while (NotDone=0)
	{
		irdr=RIGHT_IR;
		irdl=LEFT_IR;
	 
		if (irdr > avr & irdl < avl)
			speedl=speedl-1;
	 
		if (irdr < avr & irdl > avl)
			speedr=speedr-1;
	 
		if (irdr > avr & irdl > avl)
		{
			tempr=speedr;
			templ=speedl;
			speedr=0;
			speedl=0;
			NotDone=1;
		}
		motorp(RIGHT_MOTOR, speedr);
		motorp(LEFT_MOTOR, speedl);
		wait (35);
	}
	START;
	NotDone=0;
	}
}


void init_PA(void)
{
	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
	SET_BIT(PACTL, 0x40); /*Enable PA*/
	

	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */

	INTR_ON();
}

void PAV_isr(void)
{
	CLEAR_FLAG(TFLG2, 0x20);
}