#ifndef __MATH_H
#define __MATH_H

double exp10(double x);				/* 10 ** x */
double exp(double x);				/* e ** x */
double log(double x);				/* ln x */
double log10(double x);				/* log 10 of x */
double pow(double x, double y);		/* x ** y */
double fabs(double);
double fmod(double, double);
double sqrt(double x);

/* Note that these functions now use RADIAN arguments, as
 * per ANSI C rules
 */
double sin(double x);
double cos(double x);
double tan(double x);
double asin(double x);
double acos(double x);
double atan(double x);
double degree_to_radian(double);
double radian_to_degree(double);

#if 0
double modf(double v, double *ip);	/* break v into fractional and integral */
#endif

#endif
