	.include "long.h"

	.area text
; move 0,y to lreg
__ly2reg::
	pshb
	psha
  xgdx
  subd #8
  xgdx
	ldd HIY,y
	std HI1,x
	ldd LOY,y
	std LO1,x
  ldab #8
  abx
	pula
	pulb
	rts

__ly2reg_x::
	pshb
	psha
	ldd HIY,y
	std HI1,x
	ldd LOY,y
	std LO1,x
	pula
	pulb
	rts

__ly2reg2::
	pshb
	psha
  xgdx
  subd #8
  xgdx
	ldd HIY,y
	std HI2,x
	ldd LOY,y
	std LO2,x
  ldab #8
  abx
	pula
	pulb
	rts

; move lreg to 0,y
__lreg2y::
	pshb
	psha
  xgdx
  subd #8
  xgdx
	ldd HI1,x
	std	HIY,y
	ldd LO1,x
	std LOY,y
  ldab #8
  abx
	pula
	pulb
	rts

__lreg2y_x::
	pshb
	psha
	ldd HI1,x
	std	HIY,y
	ldd LO1,x
	std LOY,y
	pula
	pulb
	rts

; move lreg2 to 0,y
__lreg22y::
	pshb
	psha
  xgdx
  subd #8
  xgdx
	ldd HI2,x
	std	HIY,y
	ldd LO2,x
	std LOY,y
  ldab #8
  abx
	pula
	pulb
	rts

; move lreg to lreg2
__lregmov::
	pshb
	psha
  xgdx
  subd #8
  xgdx
	ldd HI1,x
	std HI2,x
	ldd LO1,x
	std LO2,x
  ldab #8
  abx
	pula
	pulb
	rts

; move D to lreg
__d2lreg::
  pshb
  psha
  xgdx
  subd #8
  xgdx
	clr HI1,x
	clr HI1+1,x
  pula
  pulb
	std	LO1,x
tneg:
	bge done1
	com HI1,x
	com HI1+1,x
done1:
  ldab #8
  abx
	rts

__d2lreg2::
  pshb
  psha
  xgdx
  subd #8
  xgdx
	clr HI2,x
	clr HI2+1,x
  pula
  pulb
	std	LO2,x
tneg2:
	bge	done2
	com HI2,x
	com HI2+1,x
done2:
  ldab #8
  abx
	rts

__ud2lreg::
  pshb
  psha
  xgdx
  subd #8
  xgdx
  pula
  pulb
	std	LO1,x
	clr HI1,x
	clr HI1+1,x
  ldab #8
  abx
	rts

__ud2lreg2::
  pshb
  psha
  xgdx
  subd #8
  xgdx
  pula
  pulb
	std	LO2,x
	clr HI2,x
	clr HI2+1,x
  ldab #8
  abx
	rts

; move lreg to D
__lreg2d::
  xgdx
  subd #8
  xgdx
	ldd LO1,x
  pshb
  ldab #8
  abx
  pulb
	rts

; return lreg1 to previous frame's lreg1
; users better use function prototype!!
;
; jsr __lret
; .word framesize
__lret::
	pshb
	psha

	tsy
	ldy 2,y		; get rts, which points to framesize
	ldd 0,x		; get X
	addd 0,y	; D <- X + framesize, address of old IX
	xgdy		; 
	ldd 0,y		; load old IX
	subd #4		; -4,oldIX, the lreg1 of previous func
	xgdy
	jsr __lreg2y

	pula
	pulb
	puly	; rts
	jmp 2,y	; skip .word

; spill area:
__pshlr1::
	pshy		; save y
	tsy
	ldy 2,y		; old rts
	pshy
	tsy
	ldy 2,y		; saved y
	pshy
	pshb
	ldab #2+2+1	; skip past rts, y, b
	tsy
	aby
	jsr __lreg2y
	pula
	puly
	rts

__pshlr2::
	pshy		; save y
	tsy
	ldy 2,y		; old rts
	pshy
	tsy
	ldy 2,y		; saved y
	pshy
	pshb
	ldab #2+2+1	; skip past rts, y, b
	tsy
	aby
	jsr __lreg22y
	pulb
	puly
	rts

__pullr1::
	pshy
	pshb
	psha
	ldab #2+2+2	; skip past rts, y, D
	tsy
	aby
	jsr __ly2reg
	tsy
	ldd 4,y		; get rts
	std 8,y		
	pula
	pulb
	puly
	ins
	ins
	ins
	ins
	rts

__pullr2::
	pshy
	pshb
	psha
	ldab #2+2+2	; skip past rts, y, D
	tsy
	aby
	jsr __ly2reg2
	tsy
	ldd 4,y		; get rts
	std 8,y		
	pula
	pulb
	puly
	ins
	ins
	ins
	ins
	rts
