extern float _uint2fp(int);

float _c_long2fp(long l)
	{
	float f;
	unsigned int i;
	int isneg = 0;

	i = l;
	if (i == l)
		return _uint2fp(i);
	if (l < 0)
		{
		isneg = 1;
		l = -l;
		/* this will generate a warning from the compiler, ignore it */
		i = -i;
		}
	f = _uint2fp(i);
	i = (l >> 16);
	f = f + _uint2fp(i)*65536.0;
	if (isneg)
		return -f;
	return f;
	}

