	.area	text
; 16x16 unsigned multiply, giving 32-bit results
; D*IY=IY:D
;
__muli::
__mulu::
	pshx	; save registers
	pshy
	pshb
	psha

	pshx	; scratch space for result
	pshx
	tsx
	; D is in 4,x and 5,x
	; Y is in 6,x and 7,x
	; result is 0,x (high word) and 2,x (low word)

	ldd #0
	std 0,x

; low(D)*low(Y) -> low result
	ldaa 5,x
	ldab 7,x
	mul
	std 2,x

	ldaa 5,x
	ldab 6,x
	mul
	addd 1,x
	std 1,x

	ldaa 4,x
	ldab 7,x
	mul
	addd 1,x
	std 1,x
	rol 0,x

	ldaa 4,x
	ldab 6,x
	mul
	addd 0,x
	std 0,x

	puly	; hi word of result
	pula	; low word of result
	pulb

	pulx
	pulx	; pull off args

	pulx	; restore X
	rts
