	.module left.c
	.dbfile left.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\spinuzza\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 38
; #include <stdio.h>
; #include <tjpbase.h>
; #include <algconst.h>
; 
; #pragma interrupt_handler PAV_isr
; 
; void PAV_isr(void);
; void init_PA(void);
; void TURN_LEFT(void);
; 
; int speedr, speedl, counter, done;
; 
; void main(void)
; {
; 	init_analog();
; 	init_motortjp();
; 	init_clocktjp();
; 	init_PA();
; 
; 	while(1)
; 	{
; 		START;
; 		
; 		counter=0;
; 		PACNT=0x00;
; 
; 		TURN_LEFT();
; 	
; 	}
; }
; 	
; 	
; void TURN_LEFT(void)
; {
; 			counter=1;
; 			PACNT=0x80;
; 			done=0;
; 			
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 44
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
; 			motorp(LEFT_MOTOR, MAX_LEFT);
; 			while(done==0)
; 			{
; 				asm("NOP");
; 			}
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 57
; 
; //		printf("\nNumber of overflows: %d\n",counter);
; //		printf("PACNT - %d\n",PACNT);
; 
; 			counter=1;
; 			PACNT = 0x40;			
; 			done=0;
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
; 			motorp(LEFT_MOTOR, 0);
; 			while(done==0)
; 			{
; 				asm("NOP");
; 			}
L4:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 63
; 			
; //		printf("\nNumber of overflows: %d\n",counter);
; //		printf("PACNT - %d\n",PACNT);
; 
; 			counter=1;
; 			PACNT = 0x80;
L5:
	rti
;  IX -> 0,x
_TOC4_isr::
	.dbfunc TOC4_isr
	.dbline 75
; 			done=0;			
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
; 			motorp(LEFT_MOTOR, MAX_LEFT);
; 			while(done==0)
; 			{
; 				asm("NOP");
; 			}
; 			
; 
; //		printf("\nNumber of overflows: %d\n",counter);
; //		printf("PACNT - %d\n",PACNT);
; 
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 81
; 			motorp(RIGHT_MOTOR, 0);
; 			motorp(LEFT_MOTOR, 0);			
; }
; 
; 
; void init_PA(void)
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 87
; {
; 	INTR_OFF();
; 
; 	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
; 	SET_BIT(PACTL, 0x40); /*Enable PA*/
; 	
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 99
; 
; 	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
; 	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */
; 
; 	PACNT=0x00;
; 
; 	INTR_ON();
; }
; 
; void PAV_isr(void)
; {
; 	if(counter==0)
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 105
; 	{
; 		motorp(RIGHT_MOTOR,0);
; 		motorp(LEFT_MOTOR,0);
; 		done=1;
; 	}
; 	else
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 111
; 	{
; 		counter--;
; 	}
; 	
; 	CLEAR_FLAG(TFLG2, 0x20);
; }
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 117
; }
; }
; }
; }
; }
; }
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 123
; }
; }
; }
; }
; }
; }
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 129
; }
; }
; }
; }
; }
; }
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 135
; }
; }
; }
; }
; }
; }
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 141
; }
; }
; }
; }
; }
; }
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 147
; }
; }
; }
; }
; }
; }
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 153
; }
; }
; }
; }
; }
; }
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area text
;  IX -> 0,x
_main::
	.dbfile left.c
	.dbfunc main
	.dbline 15
	jsr _init_analog
	.dbline 16
	jsr _init_motortjp
	.dbline 17
	jsr _init_clocktjp
	.dbline 18
	jsr _init_PA
	bra L21
L23:
	.dbline 22
L24:
	ldd #0
	jsr _analog
	cpd #120
	blt L23
	.dbline 24
	ldd #0
	std _counter
	.dbline 25
	clr 0x1027
	.dbline 27
	jsr _TURN_LEFT
	.dbline 29
L21:
	.dbline 20
	bra L24
L19:
	rts
;  IX -> 0,x
_TURN_LEFT::
	.dbfunc TURN_LEFT
	.dbline 35
	ldd #1
	std _counter
	.dbline 36
	ldab #128
	stab 0x1027
	.dbline 37
	ldd #0
	std _done
	.dbline 39
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 40
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L28
L27:
		NOP

	.dbline 44
L28:
	.dbline 41
	ldd _done
	beq L27
	.dbline 49
	ldd #1
	std _counter
	.dbline 50
	ldab #64
	stab 0x1027
	.dbline 51
	ldd #0
	std _done
	.dbline 52
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 53
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L31
L30:
		NOP

	.dbline 57
L31:
	.dbline 54
	ldd _done
	beq L30
	.dbline 62
	ldd #1
	std _counter
	.dbline 63
	ldab #128
	stab 0x1027
	.dbline 64
	ldd #0
	std _done
	.dbline 65
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 66
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L34
L33:
		NOP

	.dbline 70
L34:
	.dbline 67
	ldd _done
	beq L33
	.dbline 76
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 77
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 78
L26:
	rts
;  IX -> 0,x
_init_PA::
			sei

	.dbfunc init_PA
	.dbline 85
	ldy #0x1026
	bclr 0,y,#0xb0
	.dbline 86
	ldy #0x1026
	bset 0,y,#64
	.dbline 89
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 90
	ldy #0x1024
	bset 0,y,#32
	.dbline 92
	clr 0x1027
			cli

	.dbline 95
L36:
	rts
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 99
	ldd _counter
	bne L38
	.dbline 101
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 102
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 103
	ldd #1
	std _done
	.dbline 104
	bra L39
L38:
	.dbline 107
	ldd _counter
	subd #1
	std _counter
	.dbline 108
L39:
	.dbline 110
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 111
L37:
	rti
	.area bss
_done::
	.blkb 2
_counter::
	.blkb 2
_speedl::
	.blkb 2
_speedr::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
