	.module mturn.c
	.dbfile mturn.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\spinuzza\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 38
; #include <stdio.h>
; #include <tjpbase.h>
; #include <algconst.h>
; 
; #pragma interrupt_handler PAV_isr
; 
; void PAV_isr(void);
; void init_PA(void);
; void TURN_RIGHT(void);
; 
; int speedr, speedl, counter;
; 
; void main(void)
; {
; 	init_analog();
; 	init_motortjp();
; 	init_clocktjp();
; 	init_PA();
; 
; 	while(1)
; 	{
; 		START;
; 		
; 		counter=0;
; 
; 		TURN_RIGHT();
; 	
; 	}
; }
; 	
; 	
; void TURN_RIGHT(void)
; {
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
; 			motorp(LEFT_MOTOR, MAX_LEFT);
; 			wait(STRAIGHT_DELAY);
; 
; 		printf("\nNumber of overflows: %d\n",counter);
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 44
; 		printf("PACNT - %d\n",PACNT);
; 
; 
; 			motorp(RIGHT_MOTOR, 0);
; 			motorp(LEFT_MOTOR, MAX_LEFT);
; 			wait(TURN_DELAY);
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 57
; 
; 		printf("\nNumber of overflows: %d\n",counter);
; 		printf("PACNT - %d\n",PACNT);
; 			
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
; 			motorp(LEFT_MOTOR, MAX_LEFT);
; 			wait(STRAIGHT_DELAY);
; 
; 		printf("\nNumber of overflows: %d\n",counter);
; 		printf("PACNT - %d\n",PACNT);
; 
; 			motorp(RIGHT_MOTOR, 0);
; 			motorp(LEFT_MOTOR, 0);			
L4:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 63
; }
; 
; 
; void init_PA(void)
; {
; 	INTR_OFF();
L5:
	rti
;  IX -> 0,x
_TOC4_isr::
	.dbfunc TOC4_isr
	.dbline 75
; 
; 	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
; 	SET_BIT(PACTL, 0x40); /*Enable PA*/
; 	
; 
; 	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
; 	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */
; 
; 	PACNT=0x00;
; 
; 	INTR_ON();
; }
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 81
; 
; void PAV_isr(void)
; {
; 	counter++;
; 	CLEAR_FLAG(TFLG2, 0x20);
; }
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 87
; }
; }
; }
; }
; }
; }
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 99
; }
; }
; }
; }
; }
; }
; }
; }
; }
; }
; }
; }
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 105
; }
; }
; }
; }
; }
; }
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 111
; }
; }
; }
; }
; }
; }
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 117
; }
; }
; }
; }
; }
; }
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 123
; }
; }
; }
; }
; }
; }
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 129
; }
; }
; }
; }
; }
; }
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 135
; }
; }
; }
; }
; }
; }
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 141
; }
; }
; }
; }
; }
; }
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 147
; }
; }
; }
; }
; }
; }
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 153
; }
; }
; }
; }
; }
; }
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area text
;  IX -> 0,x
_main::
	.dbfile mturn.c
	.dbfunc main
	.dbline 15
	jsr _init_analog
	.dbline 16
	jsr _init_motortjp
	.dbline 17
	jsr _init_clocktjp
	.dbline 18
	jsr _init_PA
	bra L21
L23:
	.dbline 22
L24:
	ldd #0
	jsr _analog
	cpd #120
	blt L23
	.dbline 24
	ldd #0
	std _counter
	.dbline 26
	jsr _TURN_RIGHT
	.dbline 28
L21:
	.dbline 20
	bra L24
L19:
	rts
;  IX -> 0,x
_TURN_RIGHT::
	.dbfunc TURN_RIGHT
	.dbline 34
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 35
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 36
	ldd #550
	jsr _wait
	.dbline 38
	ldd _counter
	pshb
	psha
	ldd #L27
	jsr _printf
	puly
	.dbline 39
	; vol
	ldab 0x1027
	clra
	pshb
	psha
	ldd #L28
	jsr _printf
	puly
	.dbline 42
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 43
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 44
	ldd #850
	jsr _wait
	.dbline 46
	ldd _counter
	pshb
	psha
	ldd #L27
	jsr _printf
	puly
	.dbline 47
	; vol
	ldab 0x1027
	clra
	pshb
	psha
	ldd #L28
	jsr _printf
	puly
	.dbline 49
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 50
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 51
	ldd #550
	jsr _wait
	.dbline 53
	ldd _counter
	pshb
	psha
	ldd #L27
	jsr _printf
	puly
	.dbline 54
	; vol
	ldab 0x1027
	clra
	pshb
	psha
	ldd #L28
	jsr _printf
	puly
	.dbline 56
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 57
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 58
L26:
	rts
;  IX -> 0,x
_init_PA::
			sei

	.dbfunc init_PA
	.dbline 65
	ldy #0x1026
	bclr 0,y,#0xb0
	.dbline 66
	ldy #0x1026
	bset 0,y,#64
	.dbline 69
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 70
	ldy #0x1024
	bset 0,y,#32
	.dbline 72
	clr 0x1027
			cli

	.dbline 75
L29:
	rts
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 79
	ldd _counter
	addd #1
	std _counter
	.dbline 80
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 81
L30:
	rti
	.area bss
_counter::
	.blkb 2
_speedl::
	.blkb 2
_speedr::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
	.area text
L28:
	.byte 'P,'A,'C,'N,'T,32,45,32,37,'d,10,0
L27:
	.byte 10,'N,'u,'m,'b,'e,'r,32,'o,'f,32,'o,'v,'e,'r,'f
	.byte 'l,'o,'w,'s,58,32,37,'d,10,0
